#HOTFIX_VERSION:cpi-Patch-6.1.0.500
package Pkg::VRTSllt61::RHEL6x8664;

sub init_padv {
    my $pkg=shift;
    $pkg->{hfvers}='6.1.1.100';
    $pkg->{oslibs}{'RHEL6.3'}={
        "libc.so.6"  =>  "glibc-2.12-1.80.el6.i686",
        "libc.so.6()(64bit)"  =>  "glibc-2.12-1.80.el6.x86_64",
        "libc.so.6(GLIBC_2.0)"  =>  "glibc-2.12-1.80.el6.i686",
        "libc.so.6(GLIBC_2.1)"  =>  "glibc-2.12-1.80.el6.i686",
        "libc.so.6(GLIBC_2.1.3)"  =>  "glibc-2.12-1.80.el6.i686",
        "libc.so.6(GLIBC_2.2.5)(64bit)"  =>  "glibc-2.12-1.80.el6.x86_64",
        "libc.so.6(GLIBC_2.3)"  =>  "glibc-2.12-1.80.el6.i686",
        "libc.so.6(GLIBC_2.7)"  =>  "glibc-2.12-1.80.el6.i686",
        "libnsl.so.1"  =>  "glibc-2.12-1.80.el6.i686",
        "rtld(GNU_HASH)"  =>  "glibc-2.12-1.80.el6.x86_64",
    };
    $pkg->{oslibs}{'RHEL6.4'}={
        "libc.so.6"  =>  "glibc-2.12-1.107.el6.i686",
        "libc.so.6()(64bit)"  =>  "glibc-2.12-1.107.el6.x86_64",
        "libc.so.6(GLIBC_2.0)"  =>  "glibc-2.12-1.107.el6.i686",
        "libc.so.6(GLIBC_2.1)"  =>  "glibc-2.12-1.107.el6.i686",
        "libc.so.6(GLIBC_2.1.3)"  =>  "glibc-2.12-1.107.el6.i686",
        "libc.so.6(GLIBC_2.2.5)(64bit)"  =>  "glibc-2.12-1.107.el6.x86_64",
        "libc.so.6(GLIBC_2.3)"  =>  "glibc-2.12-1.107.el6.i686",
        "libc.so.6(GLIBC_2.7)"  =>  "glibc-2.12-1.107.el6.i686",
        "libnsl.so.1"  =>  "glibc-2.12-1.107.el6.i686",
        "rtld(GNU_HASH)"  =>  "glibc-2.12-1.107.el6.x86_64",
    };
    $pkg->{oslibs}{'RHEL6.5'}={
        "libc.so.6"  =>  "glibc-2.12-1.132.el6.i686",
        "libc.so.6()(64bit)"  =>  "glibc-2.12-1.132.el6.x86_64",
        "libc.so.6(GLIBC_2.0)"  =>  "glibc-2.12-1.132.el6.i686",
        "libc.so.6(GLIBC_2.1)"  =>  "glibc-2.12-1.132.el6.i686",
        "libc.so.6(GLIBC_2.1.3)"  =>  "glibc-2.12-1.132.el6.i686",
        "libc.so.6(GLIBC_2.2.5)(64bit)"  =>  "glibc-2.12-1.132.el6.x86_64",
        "libc.so.6(GLIBC_2.3)"  =>  "glibc-2.12-1.132.el6.i686",
        "libc.so.6(GLIBC_2.7)"  =>  "glibc-2.12-1.132.el6.i686",
        "libnsl.so.1"  =>  "glibc-2.12-1.132.el6.i686",
        "rtld(GNU_HASH)"  =>  "glibc-2.12-1.132.el6.x86_64",
    };
    return;
}

package Pkg::VRTSvxvm61::RHEL6x8664;

sub init_padv {
    my $pkg=shift;
    $pkg->{hfvers}='6.1.1.100';
    $pkg->{oslibs}{'RHEL6.3'}={
        "glibc"  =>  "glibc-2.12-1.80.el6.i686 glibc-2.12-1.80.el6.x86_64",
        "libgcc"  =>  "libgcc-4.4.6-4.el6.i686 libgcc-4.4.6-4.el6.x86_64",
        "libstdc++"  =>  "libstdc++-4.4.6-4.el6.i686 libstdc++-4.4.6-4.el6.x86_64",
        "nss-softokn-freebl(x86-32)"  =>  "nss-softokn-freebl-3.12.9-11.el6.i686",
        "parted"  =>  "parted-2.1-18.el6.x86_64",
        "policycoreutils"  =>  "policycoreutils-2.0.83-19.24.el6.x86_64",
    };
    $pkg->{oslibs}{'RHEL6.4'}={
        "glibc"  =>  "glibc-2.12-1.107.el6.i686 glibc-2.12-1.107.el6.x86_64",
        "libgcc"  =>  "libgcc-4.4.7-3.el6.i686 libgcc-4.4.7-3.el6.x86_64",
        "libstdc++"  =>  "libstdc++-4.4.7-3.el6.i686 libstdc++-4.4.7-3.el6.x86_64",
        "nss-softokn-freebl(x86-32)"  =>  "nss-softokn-freebl-3.12.9-11.el6.i686",
        "parted"  =>  "parted-2.1-19.el6.x86_64",
        "policycoreutils"  =>  "policycoreutils-2.0.83-19.30.el6.x86_64",
    };
    $pkg->{oslibs}{'RHEL6.5'}={
        "glibc"  =>  "glibc-2.12-1.132.el6.i686 glibc-2.12-1.132.el6.x86_64",
        "libgcc"  =>  "libgcc-4.4.7-4.el6.i686 libgcc-4.4.7-4.el6.x86_64",
        "libstdc++"  =>  "libstdc++-4.4.7-4.el6.i686 libstdc++-4.4.7-4.el6.x86_64",
        "nss-softokn-freebl(x86-32)"  =>  "nss-softokn-freebl-3.14.3-9.el6.i686",
        "parted"  =>  "parted-2.1-21.el6.x86_64",
        "policycoreutils"  =>  "policycoreutils-2.0.83-19.39.el6.x86_64",
    };
    return;
}

package Pkg::VRTSaslapm61::Linux;

sub init_plat {
    my $pkg=shift;
    $pkg->{donotrmonupgrade}=1;
    $pkg->{hfvers}='6.1.1.200';
    return;
}

package Pkg::VRTSfsadv61::RHEL6x8664;

sub init_padv {
    my $pkg=shift;
    $pkg->{oslibs}{'RHEL6.3'}={
        "libacl.so.1()(64bit)"  =>  "libacl-2.2.49-6.el6.x86_64",
        "libacl.so.1(ACL_1.0)(64bit)"  =>  "libacl-2.2.49-6.el6.x86_64",
        "libcrypto.so.10()(64bit)"  =>  "openssl-1.0.0-20.el6_2.5.x86_64",
        "libcrypt.so.1()(64bit)"  =>  "glibc-2.12-1.80.el6.x86_64",
        "libcrypt.so.1(GLIBC_2.2.5)(64bit)"  =>  "glibc-2.12-1.80.el6.x86_64",
        "libc.so.6()(64bit)"  =>  "glibc-2.12-1.80.el6.x86_64",
        "libc.so.6(GLIBC_2.2.5)(64bit)"  =>  "glibc-2.12-1.80.el6.x86_64",
        "libc.so.6(GLIBC_2.3.3)(64bit)"  =>  "glibc-2.12-1.80.el6.x86_64",
        "libc.so.6(GLIBC_2.3.4)(64bit)"  =>  "glibc-2.12-1.80.el6.x86_64",
        "libc.so.6(GLIBC_2.3)(64bit)"  =>  "glibc-2.12-1.80.el6.x86_64",
        "libdl.so.2()(64bit)"  =>  "glibc-2.12-1.80.el6.x86_64",
        "libdl.so.2(GLIBC_2.2.5)(64bit)"  =>  "glibc-2.12-1.80.el6.x86_64",
        "libgcc_s.so.1()(64bit)"  =>  "libgcc-4.4.6-4.el6.x86_64",
        "libgcc_s.so.1(GCC_3.0)(64bit)"  =>  "libgcc-4.4.6-4.el6.x86_64",
        "libm.so.6()(64bit)"  =>  "glibc-2.12-1.80.el6.x86_64",
        "libm.so.6(GLIBC_2.2.5)(64bit)"  =>  "glibc-2.12-1.80.el6.x86_64",
        "libnsl.so.1()(64bit)"  =>  "glibc-2.12-1.80.el6.x86_64",
        "libpthread.so.0()(64bit)"  =>  "glibc-2.12-1.80.el6.x86_64",
        "libpthread.so.0(GLIBC_2.2.5)(64bit)"  =>  "glibc-2.12-1.80.el6.x86_64",
        "libpthread.so.0(GLIBC_2.3.2)(64bit)"  =>  "glibc-2.12-1.80.el6.x86_64",
        "libpthread.so.0(GLIBC_2.3.3)(64bit)"  =>  "glibc-2.12-1.80.el6.x86_64",
        "librt.so.1()(64bit)"  =>  "glibc-2.12-1.80.el6.x86_64",
        "librt.so.1(GLIBC_2.2.5)(64bit)"  =>  "glibc-2.12-1.80.el6.x86_64",
        "libssl.so.10()(64bit)"  =>  "openssl-1.0.0-20.el6_2.5.x86_64",
        "libstdc++.so.6()(64bit)"  =>  "libstdc++-4.4.6-4.el6.x86_64",
        "libstdc++.so.6(CXXABI_1.3)(64bit)"  =>  "libstdc++-4.4.6-4.el6.x86_64",
        "libstdc++.so.6(GLIBCXX_3.4.5)(64bit)"  =>  "libstdc++-4.4.6-4.el6.x86_64",
        "libstdc++.so.6(GLIBCXX_3.4)(64bit)"  =>  "libstdc++-4.4.6-4.el6.x86_64",
        "libz.so.1()(64bit)"  =>  "zlib-1.2.3-27.el6.x86_64",
        "rtld(GNU_HASH)"  =>  "glibc-2.12-1.80.el6.x86_64",
    };
    $pkg->{oslibs}{'RHEL6.4'}={
        "libacl.so.1()(64bit)"  =>  "libacl-2.2.49-6.el6.x86_64",
        "libacl.so.1(ACL_1.0)(64bit)"  =>  "libacl-2.2.49-6.el6.x86_64",
        "libcrypto.so.10()(64bit)"  =>  "openssl-1.0.0-27.el6.x86_64",
        "libcrypt.so.1()(64bit)"  =>  "glibc-2.12-1.107.el6.x86_64",
        "libcrypt.so.1(GLIBC_2.2.5)(64bit)"  =>  "glibc-2.12-1.107.el6.x86_64",
        "libc.so.6()(64bit)"  =>  "glibc-2.12-1.107.el6.x86_64",
        "libc.so.6(GLIBC_2.2.5)(64bit)"  =>  "glibc-2.12-1.107.el6.x86_64",
        "libc.so.6(GLIBC_2.3.3)(64bit)"  =>  "glibc-2.12-1.107.el6.x86_64",
        "libc.so.6(GLIBC_2.3.4)(64bit)"  =>  "glibc-2.12-1.107.el6.x86_64",
        "libc.so.6(GLIBC_2.3)(64bit)"  =>  "glibc-2.12-1.107.el6.x86_64",
        "libdl.so.2()(64bit)"  =>  "glibc-2.12-1.107.el6.x86_64",
        "libdl.so.2(GLIBC_2.2.5)(64bit)"  =>  "glibc-2.12-1.107.el6.x86_64",
        "libgcc_s.so.1()(64bit)"  =>  "libgcc-4.4.7-3.el6.x86_64",
        "libgcc_s.so.1(GCC_3.0)(64bit)"  =>  "libgcc-4.4.7-3.el6.x86_64",
        "libm.so.6()(64bit)"  =>  "glibc-2.12-1.107.el6.x86_64",
        "libm.so.6(GLIBC_2.2.5)(64bit)"  =>  "glibc-2.12-1.107.el6.x86_64",
        "libnsl.so.1()(64bit)"  =>  "glibc-2.12-1.107.el6.x86_64",
        "libpthread.so.0()(64bit)"  =>  "glibc-2.12-1.107.el6.x86_64",
        "libpthread.so.0(GLIBC_2.2.5)(64bit)"  =>  "glibc-2.12-1.107.el6.x86_64",
        "libpthread.so.0(GLIBC_2.3.2)(64bit)"  =>  "glibc-2.12-1.107.el6.x86_64",
        "libpthread.so.0(GLIBC_2.3.3)(64bit)"  =>  "glibc-2.12-1.107.el6.x86_64",
        "librt.so.1()(64bit)"  =>  "glibc-2.12-1.107.el6.x86_64",
        "librt.so.1(GLIBC_2.2.5)(64bit)"  =>  "glibc-2.12-1.107.el6.x86_64",
        "libssl.so.10()(64bit)"  =>  "openssl-1.0.0-27.el6.x86_64",
        "libstdc++.so.6()(64bit)"  =>  "libstdc++-4.4.7-3.el6.x86_64",
        "libstdc++.so.6(CXXABI_1.3)(64bit)"  =>  "libstdc++-4.4.7-3.el6.x86_64",
        "libstdc++.so.6(GLIBCXX_3.4.5)(64bit)"  =>  "libstdc++-4.4.7-3.el6.x86_64",
        "libstdc++.so.6(GLIBCXX_3.4)(64bit)"  =>  "libstdc++-4.4.7-3.el6.x86_64",
        "libz.so.1()(64bit)"  =>  "zlib-1.2.3-29.el6.x86_64",
        "rtld(GNU_HASH)"  =>  "glibc-2.12-1.107.el6.x86_64",
    };
    $pkg->{oslibs}{'RHEL6.5'}={
        "libacl.so.1()(64bit)"  =>  "libacl-2.2.49-6.el6.x86_64",
        "libacl.so.1(ACL_1.0)(64bit)"  =>  "libacl-2.2.49-6.el6.x86_64",
        "libcrypto.so.10()(64bit)"  =>  "openssl-1.0.1e-15.el6.x86_64",
        "libcrypt.so.1()(64bit)"  =>  "glibc-2.12-1.132.el6.x86_64",
        "libcrypt.so.1(GLIBC_2.2.5)(64bit)"  =>  "glibc-2.12-1.132.el6.x86_64",
        "libc.so.6()(64bit)"  =>  "glibc-2.12-1.132.el6.x86_64",
        "libc.so.6(GLIBC_2.2.5)(64bit)"  =>  "glibc-2.12-1.132.el6.x86_64",
        "libc.so.6(GLIBC_2.3.3)(64bit)"  =>  "glibc-2.12-1.132.el6.x86_64",
        "libc.so.6(GLIBC_2.3.4)(64bit)"  =>  "glibc-2.12-1.132.el6.x86_64",
        "libc.so.6(GLIBC_2.3)(64bit)"  =>  "glibc-2.12-1.132.el6.x86_64",
        "libdl.so.2()(64bit)"  =>  "glibc-2.12-1.132.el6.x86_64",
        "libdl.so.2(GLIBC_2.2.5)(64bit)"  =>  "glibc-2.12-1.132.el6.x86_64",
        "libgcc_s.so.1()(64bit)"  =>  "libgcc-4.4.7-4.el6.x86_64",
        "libgcc_s.so.1(GCC_3.0)(64bit)"  =>  "libgcc-4.4.7-4.el6.x86_64",
        "libm.so.6()(64bit)"  =>  "glibc-2.12-1.132.el6.x86_64",
        "libm.so.6(GLIBC_2.2.5)(64bit)"  =>  "glibc-2.12-1.132.el6.x86_64",
        "libnsl.so.1()(64bit)"  =>  "glibc-2.12-1.132.el6.x86_64",
        "libpthread.so.0()(64bit)"  =>  "glibc-2.12-1.132.el6.x86_64",
        "libpthread.so.0(GLIBC_2.2.5)(64bit)"  =>  "glibc-2.12-1.132.el6.x86_64",
        "libpthread.so.0(GLIBC_2.3.2)(64bit)"  =>  "glibc-2.12-1.132.el6.x86_64",
        "libpthread.so.0(GLIBC_2.3.3)(64bit)"  =>  "glibc-2.12-1.132.el6.x86_64",
        "librt.so.1()(64bit)"  =>  "glibc-2.12-1.132.el6.x86_64",
        "librt.so.1(GLIBC_2.2.5)(64bit)"  =>  "glibc-2.12-1.132.el6.x86_64",
        "libssl.so.10()(64bit)"  =>  "openssl-1.0.1e-15.el6.x86_64",
        "libstdc++.so.6()(64bit)"  =>  "libstdc++-4.4.7-4.el6.x86_64",
        "libstdc++.so.6(CXXABI_1.3)(64bit)"  =>  "libstdc++-4.4.7-4.el6.x86_64",
        "libstdc++.so.6(GLIBCXX_3.4.5)(64bit)"  =>  "libstdc++-4.4.7-4.el6.x86_64",
        "libstdc++.so.6(GLIBCXX_3.4)(64bit)"  =>  "libstdc++-4.4.7-4.el6.x86_64",
        "libz.so.1()(64bit)"  =>  "zlib-1.2.3-29.el6.x86_64",
        "rtld(GNU_HASH)"  =>  "glibc-2.12-1.132.el6.x86_64",
    };
    return;
}


package Prod::VM61::Common;

sub upgrade_precheck_sys {
    my ($prod,$sys)= @_;
    my ($pkg,$cprod);

    $prod->large_lun_check_sys($sys);

    #fix e1518138 : uninstall AT pkgs when upgrade VM/VVR
    $cprod=CPIC::get('prod');
    if (EDRu::inarr($cprod,qw/VM61 DMP61/)) {
        $prod->obsoleted_bundles_sys($sys);
        $prod->obsoleted_bundled_pkgs_sys($sys);
    }
    $prod->obsoleted_thirdparty_pkgs_sys($sys);
    # check if dg has latest backup before upgrade
    $prod->dg_conf_upgrade_precheck_sys($sys) unless (Cfg::opt('upgrade_nonkernelpkgs'));
    if ($prod->is_encapsulated_bootdisk_sys($sys)){
        return '' unless ($prod->encap_upgrade_precheck_sys($sys));
        # set donotstop and donotremove flag here.
        $prod->set_flag_encap_upgrade_sys($sys);
    }
    # check if any cache objects enabled on the system
    $prod->cache_areas_sys($sys);
    $prod->open_volumes_sys($sys, 'upgrade') unless (Cfg::opt(qw(upgrade_nonkernelpkgs)));
    $prod->vvr_upgrade_precheck_sys($sys) if ($prod->vr_licensed_sys($sys));
    return;
}

sub large_lun_check_sys {
    my ($prod,$sys)=(@_);
    my ($tmpdir,$ivers,$disks,@disks,@disks_with_issue,$mode,$pkg,$msg);
    my ($cnt,$devcnt,$lpath,$nmp,$tmpfile,$tbnum,$tmpfile2,$vxscsi);
    my ($cap,$cyl,$ncyl,$ncyl_lmt,$nhead,$nsect,$rsize,$tb_mkr);
    my ($alt_cyl,$cyl_msb,$cyl_lsb,$cylsize,$hd,$hd_msb,$hd_lsb,$sec,$sec_msb,$sec_lsb,$tcyl);
    my ($disk_s,$disk_s2,$disk_size1,$disk_size2,$vxdisk);
    my ($label,$maxcap,$secoff,$skip_value,$tdisk_size);

    # VM have large LUN disk issue on 5.1SP1, 5.1SP1RP1, 5.1SP1RP2, 5.1SP1RP3
    # For more information, visit tech note:
    #   http://www.symantec.com/business/support/index?page=content&id=TECH155921
    $ivers=$prod->version_sys($sys);
    if ($ivers !~ /5\.1\.1\d[0123]/) {
        return 1;
    }

    # Need check large LUN if 5.1SP1, 5.1SP1RP1, 5.1SP1RP2, 5.1SP1RP3
    Msg::log("Checking large LUN: VM version: $ivers");

    # check vxvm is running
    $mode=$sys->cmd("_cmd_vxdctl mode 2>/dev/null");
    if ($mode!~/mode: enabled/) {
        # vxconfigd not running, installer will not re-start 5.1SP1 vxconfigd to gather data
        $sys->set_value('donot_restart_vxconfigd', 1);
        return 0;
    }
 
    # Check if any disk size > 1T, if yes, do not re-start 5.1SP1 vxconfigd.
    my $sol_disklmt=2147483647;
 
    $disks=$sys->cmd("_cmd_vxdisk -q list 2>/dev/null | _cmd_grep ':cdsdisk' | _cmd_grep -v error | _cmd_awk '{print \$1}' | _cmd_grep -v 'was:'");
    return 0 unless $disks;
 
    @disks=split(/\s+/,$disks);
    @disks_with_issue=();
 
    $tmpdir=EDR::tmpdir();
    $nmp=$sys->cmd("_cmd_vxddladm get namingscheme 2>/dev/null | _cmd_tail -1 | _cmd_grep New | _cmd_wc -l");
 
    for my $disk (@disks) {
        my ($flag,$flags,@flags,$format,$invalid,$len,$off,$pub);

        Msg::log("Checking if there is 1TB issue for $disk");
        if ($nmp == 1) {
            $lpath="/dev/rdisk/$disk";
        } else {
            $lpath="/dev/vx/rdmp/$disk";
        }

        # Raw Geometry Mode Sense 3/4 Values
        $vxscsi=$sys->cmd("/etc/vx/diag.d/vxscsi -g $disk");
        next if (EDR::cmdexit() != 0);
 
        $nsect=0;
        $nhead=0;
        $ncyl=0;
        if ($vxscsi=~/nsect=(\d+)\s*/){
            $nsect=$1;
        }
        if ($vxscsi=~/nhead=(\d+)\s*/){
            $nhead=$1;
        }
        if ($vxscsi=~/ncyl=(\d+)\s*/){
            $ncyl=$1;
        }
        $cap=$nsect * $nhead * $ncyl;
        next if ($cap==0);

        $cyl=int($cap / $ncyl);
        $rsize=$cap - $cyl - $cyl;
        $ncyl_lmt=int($sol_disklmt / $cyl);
        $tb_mkr=$ncyl_lmt * $cyl;
 
        # Block 0 label values
        $tmpfile="$tmpdir/".$sys->{sys}."_$disk"."_blk0.out";
        $sys->cmd("_cmd_dd if=$lpath of=$tmpfile bs=512 count=2 >/dev/null 2>&1");
        if ($sys->exists($tmpfile)) {
            $sec_msb=$sys->cmd("od -An -v -j 438 -N 1 -tuC $tmpfile 2>/dev/null");
            $sec_lsb=$sys->cmd("od -An -v -j 439 -N 1 -tuC $tmpfile 2>/dev/null");
            $sec=$sec_msb * 256 + $sec_lsb;
            $hd_msb=$sys->cmd("od -An -v -j 436 -N 1 -tuC $tmpfile 2>/dev/null");
            $hd_lsb=$sys->cmd("od -An -v -j 437 -N 1 -tuC $tmpfile 2>/dev/null");
            $hd=$hd_msb * 256 + $hd_lsb;
            $cyl_msb=$sys->cmd("od -An -v -j 432 -N 1 -tuC $tmpfile 2>/dev/null");
            $cyl_lsb=$sys->cmd("od -An -v -j 433 -N 1 -tuC $tmpfile 2>/dev/null");
            $cyl=$cyl_msb * 256 + $cyl_lsb;
            $cylsize=$sec * $hd;
            $alt_cyl=$sys->cmd("od -An -v -j 435 -N 1 -tuC $tmpfile 2>/dev/null");
            $tcyl=$cyl + $alt_cyl;
 
            # Compare Raw Geo With Block 0
            if (($sec != $nsect ) || ( $hd != $nhead ) || ( $tcyl != $ncyl ) || ($cap > $tb_mkr)) { 
                $disk_size2=$cyl * $cylsize;
 
                # Check if disk is a cdsdisk and compare VXVM disk size with Block 0 size
                $vxdisk=$sys->cmd("_cmd_vxdisk list $disk 2>/dev/null");
 
                $format='';
                $invalid='';
                $flag='';
                if ($vxdisk=~/format=(\w+)/g) {
                    $format=$1;
                }
                if ($vxdisk=~/flags:.*invalid.*/g) {
                    $invalid=1;
                }
                if ($vxdisk=~/flags:(.+)/g) {
                    $flags=$1;
                    @flags=split(/\s+/m, $flags);
                    $flag=$flags[1];
                }
                if (( $format eq "cdsdisk" ) && ( $flag eq "online" ) && ( $invalid != 1 )) {
                    if ($vxdisk=~/public:(.+)/g) {
                        $pub=$1;
                    }
                    if ($pub=~/offset=(\d+)/) {
                        $off=$1;
                    }
                    if ($pub=~/len=(\d+)/) {
                        $len=$1;
                    }
                    $disk_s=$off + $len;
                    if ($sys->{plat} eq "HPUX") {
                        $disk_s2=$disk_s * 1024;
                        $disk_size1=int($disk_s2 / 512);
                    } else {
                        $disk_size1=$disk_s;
                    }
                } else {
                    $disk_size1=0;
                }
 
                if (( $disk_size1 > $disk_size2 ) || ( $disk_size1 == 0 ) || ( $disk_size1 > $rsize ) || ($cap > $tb_mkr)) {
                    # Ensure Block 0 is not empty and has a valid label
                    if (( $sec == 0 ) && ( $hd == 0 ) && ( $tcyl == 0 ) && ( $flag !~ "error" )) {
                        if ( $format eq "cdsdisk" ) {
                            $label=$sys->cmd("_cmd_strings $tmpfile");
                            if ( $label =~ /EFI PART/g ) {
                                Msg::log("Disk $disk Passed - Labeled EFI/GPT");
                            } else {
                                Msg::log("Disk $disk -- FAILED --");
                                Msg::log("Block 0 does not contain any SMI (disk label) data, Need run 'vxdisk resize $disk' to update Block 0\n");
                                push @disks_with_issue, $disk;
                            }
                        } else {
                            if ( $format eq "hpdisk" ) {
                                Msg::log("$disk format $format - Passed");
                            } else {
                                Msg::log("$disk is not under VxVM Control");
                            }
                        }
                    } else {
                        $tdisk_size=$tcyl * $sec * $hd;
                        $secoff=$sec - 1;
                        $skip_value=$tdisk_size - $secoff;

                        # Gather the dd from the backup label location base on Block 0 values
                        if ( $disk_size1 > $skip_value) {
                            Msg::log("Disk has Smaller Label than VxVM DMSIZE");
                            Msg::log("--------$disk Lun Size's ---------");
                            if ( $format eq "cdsdisk" ) {
                                Msg::log("VxVM DM(disk media) Size = $disk_size1");
                            } else {
                                Msg::log("$disk is not under VxVM Control");
                            }
                            
                            if ($vxscsi=~/cap=(\d+)/) {
                                $maxcap=$1;
                            }
                            Msg::log("Raw Geometry Size - Max Cap=$maxcap Available Size = $rsize");
                            Msg::log("Block 0 Label Size = $disk_size2");
                            Msg::log("    ---- CYL=$tcyl SEC=$sec HD=$hd ----");
 
                            Msg::log("Disk $disk -- FAILED --");

                            # Check is the backup label Block contain backup label data search for "cyl"
                            $tmpfile2="$tmpdir/".$sys->{sys}."_$disk"."_bklbl.out";
                            $sys->cmd("_cmd_dd if=$lpath of=$tmpfile2 bs=512 count=16 skip=$skip_value >/dev/null 2>&1");
                            $cnt=$sys->cmd("_cmd_strings $tmpfile2 | _cmd_grep cyl | _cmd_head -1 | _cmd_wc -l | _cmd_awk '{print \$1}'");
                            if  ( $cnt == 1 ) {
                                Msg::log("Script has detected that Disk $disk has Block 0 data in user data region.");
                                Msg::log("Block 0 data was located on device at block offset $skip_value");
                            } else {
                                Msg::log("No Block 0 label data was detected in user data blocks");
                            }
                            push @disks_with_issue, $disk;
                        } else {
                            if (( $flag eq "error" ) || ( $invalid == 1 )) {
                                Msg::log("Disk $disk ---- FAILED");
                                push @disks_with_issue, $disk;
                            } else {
                                if ( $cap > $tb_mkr ) {
                                    Msg::log("Disk $disk ---- FAILED");
                                    Msg::log("Lun $disk greater than 1TB with an SMI label\n");
                                    push @disks_with_issue, $disk;
                                } else {
                                    Msg::log("Size Discrepancy Noted 'Disk $disk Passed'");
                                }
                            }
                        }
                    }
                } else {
                    Msg::log("Disk $disk Passed");
                }
           } else {
               Msg::log("Disk $disk Passed ");
           }
        } else {
            Msg::log("Unable to run dd on Drive $disk");
        }
    }
 
    if ( @disks_with_issue ) {
        $sys->set_value('donot_restart_vxconfigd', 1);

        $disks=join ', ', @disks_with_issue;
        $msg=Msg::new("There are the following disks over terabyte on $sys->{sys}:\n\t$disks\nInstaller will not restart the vxconfigd due to a defect in Volume Manager of 5.1SP1 version that may potentially cause diskgroup import failures on upgrade and lead to potential data loss.\nPlease refer to the technical note for more details 'http://www.symantec.com/business/support/index?page=content&id=TECH155921'");
        $msg->log;
        return 0;
    } else {
        Msg::log("All disk Passed no action required");
        Msg::log("No User Data can get corrupted.");
    }
    return 1;
}


sub dmp_osn_stop_sys {
    my ($prod,$sys,$task) = @_;
    my ($msg,$out,$voldmode);
    my ($exitcode);

    return 0 if (Cfg::opt('rootpath'));
    return 0 if ($sys->exists("$prod->{mkdbfile}"));

    $voldmode = $prod->vold_status_sys($sys);
    if ($voldmode !~ /enabled/m) {
        if ($sys->{donot_restart_vxconfigd}) {
            return 0;
        } else {
            # If vold is down, attempt to start it
            $sys->cmd('_cmd_vxconfigd -k -r reset -x syslog 2> /dev/null');
            $voldmode = $prod->vold_status_sys($sys);
            if ($voldmode !~ /enabled/m ) {
                if (Cfg::opt('upgrade')) {
                    $msg=Msg::new("vxconfigd could not be started on $sys->{sys}. You must make sure the tunable dmp_native_support is turned off on $sys->{sys} before upgrade. It is likely that vxdmp driver will fail to stop during upgrade if the tunable is on. If OS upgrade is involved during the upgrade process, you can ignore this warning.", 40, 4907, "$sys->{sys}", "$sys->{sys}");
                } else {
                    $msg=Msg::new("vxconfigd could not be started on $sys->{sys}. You must affirm that dmp_native_support tunable is turned off or run 'vxdmpadm settune dmp_native_support=off' manually after restarting vxconfigd if you want to continue.", 40, 4496, "$sys->{sys}");
                }
                $sys->push_warning($msg);
                return 0;
            }
        }
    }

    $out = $sys->cmd('_cmd_vxdmpadm gettune dmp_native_support 2> /dev/null');
    if ($out =~ /dmp_native_support\s+on/mx) {
        Msg::log("Detected OS native stack support is enabled on $sys->{sys} before $task, turn it off...");
        $out = $sys->cmd('_cmd_vxdmpadm settune dmp_native_support=off 2>&1');
        $exitcode = EDR::cmdexit();
        # e2851114: While making dmp_native_support off on Linux, it returns with value 215 (VE_REBOOT_REQUIRED 471). Should regard return value of 215 is successful on Linux.
        # check if $exitcode is -41 because in EDR $exitcode -= 256 if ($exitcode > 127);
        $exitcode = 0 if ($exitcode eq '-41');
        if ($exitcode) {
            if ($out =~ /\brootvg\b/m) {
                # error for AIX LVM
                $msg = Msg::new("Failed to turn off dmp_native_support tunable on $sys->{sys}. Refer to Dynamic Multi-Pathing Administrator's guide to determine the reason for the failure and take corrective action. Re-run bosboot manually.", 40, 4497, "$sys->{sys}");
            } else {
                # other error
                $msg = Msg::new("Failed to turn off dmp_native_support tunable on $sys->{sys}. Refer to Dynamic Multi-Pathing Administrator's guide to determine the reason for the failure and take corrective action.", 40, 4498, "$sys->{sys}");
            }
            $msg->{msg} .= "\n$out";
            $sys->push_error($msg);
        } else {
            if ($out =~ /\breboot\b/im) {
                $msg = Msg::new("System $sys->{sys} needs reboot to disable dmp native support on $sys->{sys}. Re-run the installer after a reboot.", 40, 5935, "$sys->{sys}", "$sys->{sys}");
                $sys->push_warning($msg);
                $sys->set_value('reboot', 1);
                $sys->set_value('warning_exit', 1);
            }
        }
        # touch /etc/vx/.migrate_native to turn on dmp native support later
        $sys->cmd("_cmd_touch $prod->{migrate_native_file}") if (Cfg::opt(qw(upgrade patchupgrade hotfixupgrade stop)));
    } else {
        # It is possible that dmp_native_support tunnable is off
        # but rootvg is still under DMP control
        if ($sys->aix()) {
            $out = $sys->cmd('_cmd_vxdmpadm native list vgname=rootvg 2>&1');
            if (EDR::cmdexit() == 0 || $out !~ /ERROR/) {
                # rootvg is still under DMP control
                $out=$sys->cmd('_cmd_vxdmpadm native disable vgname=rootvg 2>&1');
                if($out =~ /\breboot\b/im) {
                    $msg=Msg::new("System $sys->{sys} needs reboot to disable dmp root support on $sys->{sys}. Re-run the installer after a reboot.", 40, 5936, "$sys->{sys}", "$sys->{sys}");
                    $sys->push_warning($msg);
                    $sys->set_value('reboot', 1);
                    $sys->set_value('warning_exit', 1);
                }
            }
        }
    }

    return 1;
}

sub vvr_upgrade_precheck_sys {
    my ($prod,$sys)= @_;
    my ($dg,@dgs,$msg,$rvg,$shared,$voldmode,$vvr);
    # check vxdctl mode
    # Follow upgrade procedure if VRTSvxvm is being upgraded
    # But just check whether the sys is being upgraded.
    return if ($sys->exists("$prod->{mkdbfile}"));
    $voldmode = $sys->cmd('_cmd_vxdctl mode 2> /dev/null');
    if ($voldmode !~ /mode: enabled/m ) {
        if ($sys->{donot_restart_vxconfigd}) {
            return '';
        } else {
            # If vold is down, atempt to start it
            $sys->cmd('_cmd_vxconfigd -k -r reset -x syslog 2> /dev/null');
            $voldmode = $sys->cmd('_cmd_vxdctl mode 2> /dev/null');
            if ($voldmode !~ /mode: enabled/m ) {
            # the same message has already been pushed into warning in the function dg_conf_upgrade_precheck_sys
            #    $msg=Msg::new("vxconfigd could not be started on $sys->{sys}. Upgrading VRTSvxvm in this scenario can result in configuration errors, or data loss for Veritas Volume Manager objects. Continue if you are sure that there are no Veritas Volume Manager objects on the host.");
            #    $sys->push_warning($msg);
                return '';
            }
        }
    }

    # check dg version
    # Iterate twice
    $dg=$sys->cmd("_cmd_vxdg -q list 2>/dev/null | _cmd_awk '{ print \$1 }'");
    @dgs=split(/\s+/m,$dg);
    for my $dg (@dgs) {
        $rvg = $sys->cmd("_cmd_vxprint -g $dg -qQVF%name 2>/dev/null");
        if ($rvg) {
            $vvr = 1;
            $sys->set_value('rvg','1');
            last;
        }
    }
    return unless ($vvr);
    for my $dg (@dgs) {
        $shared = $sys->cmd("_cmd_vxdg list $dg 2> /dev/null | _cmd_grep 'flags:' | _cmd_grep shared");
        next if ($shared);
        $prod->vvr_check_dg_version_sys($sys, $dg);
    }
    return;
}

sub dg_conf_upgrade_precheck_sys {
    my ($prod,$sys) = @_;
    my ($cf_bkup_path,$cmd,$dg,$dgid,$dglist,$msg,$rootpath,$voldmode);
    return if ($sys->exists("$prod->{mkdbfile}"));
    return if ($prod->vol_is_vm_disabled_sys($sys));
    $voldmode = $prod->vold_status_sys($sys);
    if ($voldmode !~ /enabled/m ) {
        if ($sys->{donot_restart_vxconfigd}) {
            return '';
        } else {
            # If vold is down, atempt to start it
            # firstly try to start without '-r reset' since '-r reset' will increase dg seq no
            if ($voldmode =~ /not-running/m) {
                Msg::log("vxconfigd is not running on $sys->{sys}; restarting");
                $sys->cmd('_cmd_vxconfigd -k -x syslog 2> /dev/null');
            } else {
                # the mode could be disabled or booted
                Msg::log("vxconfigd is in $voldmode on $sys->{sys}; re-enabling");
                $sys->cmd('_cmd_vxdctl enable >/dev/null 2>&1');
            }
            $voldmode = $prod->vold_status_sys($sys);
            if ($voldmode !~ /enabled/m ) {
                $sys->cmd('_cmd_vxconfigd -k -r reset -x syslog 2> /dev/null');
                $voldmode = $prod->vold_status_sys($sys);
                if ($voldmode !~ /enabled/m ) {
                    $msg=Msg::new("The vxconfigd utility could not be started on $sys->{sys}. Upgrading VRTSvxvm in this scenario can result in configuration errors, or data loss for Veritas Volume Manager objects. Continue if you are sure that there are no Veritas Volume Manager objects on the host.", 40, 5948, "$sys->{sys}");
                    $sys->push_warning($msg);
                    return '';
                }
            }
        }
    }
    $rootpath = Cfg::opt("rootpath");
    $cf_bkup_path = "$rootpath$prod->{cf_bkup_path}";
    $dglist = $sys->cmd("_cmd_vxdg -q list 2> /dev/null");
    for my $line(split(/\n/,$dglist)) {
        if ($line =~ /(\S+)\s+\S+\s+(\S+)/m) {
            $dg = $1;
            $dgid = $2;
        }
        if ($prod->is_dg_seqno_change_sys($sys,$dg,$dgid)) {
            $sys->set_value('dgs_need_backup','push',$dg);
        }

        # For 2808458: to check if any imported dg with mix of regular and clone disks
        if ($prod->is_dg_mix_clone_sys($sys,$dg)) {
            $sys->set_value('dgs_mix_clone','push',$dg);
        }
    }
    if ($sys->{dgs_need_backup}) {
        $dglist = join(" ", @{$sys->{dgs_need_backup}});
        $cmd = $prod->padv->{cmd}{vxconfigbackup};
        $msg = Msg::new("The following disk group(s) do not have the latest backup of configuration files in $cf_bkup_path on $sys->{sys} before upgrade:\n\t$dglist\nRun the command '$cmd -l [dir] [dgname|dgid]' to take the latest backup of them. The default backup directory $cf_bkup_path on $sys->{sys} may be removed during upgrade. Manually copy the directory to other places if you would like to keep the backup files.", 40, 5069, "$cf_bkup_path", "$sys->{sys}", "$dglist", "$cmd", "$cf_bkup_path", "$sys->{sys}");
        $sys->push_warning($msg);
    } elsif ($dglist) {
        $msg = Msg::new("The default backup directory $cf_bkup_path on $sys->{sys} may be removed during upgrade. Manually copy the directory to other places if you would like to keep the backup of the configuration files for the disk groups before upgrade.", 40, 5949, "$cf_bkup_path", "$sys->{sys}");
        $sys->push_warning($msg);
    }

    if ($sys->{dgs_mix_clone}) {
        $dglist = join(" ", @{$sys->{dgs_mix_clone}});
        $msg = Msg::new("The following disk group(s) have a mix of regular and clone disk on $sys->{sys}:\n\t$dglist\nFollow the instructions in 'Clearing the udid_mismatch flag for non-clone disks' in the Symantec Storage Foundation and High Availability Solutions Troubleshooting guide to unset clone flags before an upgrade.", 40, 5950, "$sys->{sys}", "$dglist");
        $sys->push_error($msg);
    }
    return;
}

package Rel::UXRT61::Linux;

sub get_platreqs {
    my ($rel,$prod) = @_;
    my ($platreqs,$non_uekreqs);
    #e3535822:remove uek kernel from the product kernel list except vcs
    $rel->get_required_os_versions();
    $platreqs = $prod->{platreqs} || $rel->{platreqs};

    if ($prod->{prod} !~ /Availability/i) {
        for my $req (@{$platreqs}) {
            next if ($req =~ /uek/i);
            push @{$non_uekreqs}, $req;
        }
        return $non_uekreqs;
    } else {
        return $platreqs;
    } 
}

# get the required OS/Kernel versions from Rel Matrix
# previously we hard code for this
sub get_required_os_versions {
    my $rel = shift;
    my ($cpic,$padv,@array,$plat,$os_update_min,$os_update_max,$level,$os_version,@required_os);

    $cpic = Obj::cpic();
    $padv = $rel->{sort_padv};
    @array = split(/\_/,$padv);
    $plat = $array[0];
    $plat =~ tr/[a-z]/[A-Z]/;

    $os_update_min = $rel->{os_update_min};
    $os_update_max = $rel->{os_update_max};

    for my $key (sort compare_kernel_string keys %{$rel->{kernel_padv}{$padv}}) {
        $level = $rel->{kernel_padv}{$padv}->{$key};
        if ($level >= $os_update_min && $level <= $os_update_max) {
            $os_version = $key;
            # for RHEL, the format is 'RHEL6 U4 (2.6.32-358.el6)'
            # for SLES, the format if 'SLES11 SP3 (3.0.76)'
            if ($plat =~ /^RHEL(\d+)$/mx) { 
                $os_version = "$plat U$level ($os_version.el$1)";
            } else {
                $os_version = "$plat SP$level ($os_version)";
            }   
            push (@required_os,$os_version);
        }
    }
    
    # for RHEL, need to add OL uek kernel to array
    if (($plat =~ /^RHEL\d+/m) && $rel->{platreqs}) {
        for my $platreq (@{$rel->{platreqs}}) {
            push (@required_os,$platreq) unless ($platreq =~ /^RHEL\d+/m); 
        }    
    }

    # update it in order to diplay the latest required OS versions
    $rel->{platreqs} = \@required_os;

    return 1;
}

sub compare_kernel_string {
    my (@a,@b,$length,$i);
    @a=split(/-/,$a);
    @b=split(/-/,$b);
    $i=0;
    $length=scalar(@a) > scalar(@b)? scalar(@b) : scalar(@a);
    
    while ($i < $length) {
        if (EDRu::compvers($a[$i],$b[$i])==1) {
            return 1;
        } elsif (EDRu::compvers($a[$i],$b[$i])==2) {
            return -1;
        } else {
            $i++;
        }
    }
    return 1;
}

sub get_sort_kernel {
    my ($rel,$kstring,$sort_padv)=@_;
    # on SLES platform, remove the tailing non digits after - 
    if ($sort_padv=~/^sles/) {
        $kstring =~ s/-\D.*$//;
    }
    for my $kernel (keys%{$rel->{kernel_padv}{$sort_padv}}) {
        if ($kstring =~ /^$kernel/ || $kernel =~ /^$kstring/) {
            return $kernel;
        }
    }
    Msg::log("Failed to retrieve the OS minor version from kernel $kstring");
    return '';
}

sub must_have_patch_sys {
    my ($rel,$sys,$patchid)=@_;
    my ($sort_padv,$patch_hash,$pkg,$pkgname,$patch_arg,@pkglist,$cpic,$prod,@prods);
    
    $cpic=Obj::cpic();
    $prod=$cpic->prod->{prod};
    $sort_padv=$rel->{sort_padv};
    $patch_hash=$rel->{release_matrix}{$sort_padv}{hotfix}{$patchid}{patch};
    $patch_arg=$rel->{patcharg};
    @prods=split(/,/,$rel->{release_matrix}{$sort_padv}{hotfix}{$patchid}{products});
    
    # Skip the patch if it's not for the product
    unless (EDRu::inarr(lc($prod),@prods)) {
        Msg::log("Patch $patchid is not required by $prod");
        return 0;
    }

    # If the patch(same or higher version) will be applied or already installed, skip this patch
    for my $key (keys %{$patch_hash}) {
        # Reset version
        my ($patch_version,$installed_version,$version);
        $pkgname = $patch_hash->{$key}{pkgs}[0];
        $patch_version = $patch_hash->{$key}{version};
        $installed_version = $sys->{pkgvers}{$pkgname};
        @pkglist=(grep {$_ =~ /$pkgname/} keys %$patch_arg);
        if (@pkglist) {
            # We don't consider the possibility that mutiple patch exists for the same package
            $pkg=$pkglist[0];
            if ($pkg =~ /\D+_(\w+)$/) {
                $version=$1;
                $version=~s/_/./g;
            }
        }
        # Choose the higher version to compare with $patch_version
        $version = (EDRu::compvers($installed_version,$version,4)==1) ? $installed_version : $version;
        if (EDRu::compvers($patch_version,$version,4)==1) {
            return 1;
        }
    }
    return 0;
}

# Just status display message are commented because we are following KISS as different no. of status messages on
# different plats create unnecessary complexity for EDR
sub platvers_sys {
    my ($rel,$sys) = @_;
    my ($patchlevel,$msg,$rpm_dir,$kret,$ksles,$padv,$kstring,$cpic,@f,$distro,@pkg_files,$pkg,$prod);
    my ($localsys,$mediapath,$tmpdir,$vmware,$testVMware,$vmware_script,@vmware_tool_scripts,$state,$platreqs,$platvers);
    my ($sort_padv,$os_update_min,$os_update_max,$os_update_err,$os_update,$required_patch_id,$sort_kernel);
    $sys=Obj::sys($sys) unless (ref($sys) eq 'Sys');
    return '' if ($sys->{stop_checks});
    return '' if (Cfg::opt('ignorechecks'));

    $cpic=Obj::cpic();
    $prod=$sys->prod($cpic->{prod});
    $padv=$sys->padv($sys->{padv});
    $distro=$padv->distro_sys($sys);
    $kstring=$sys->cmd('_cmd_uname -r');
    $kstring =~ /\-(\d+)/m;
    $kret = $1;
    $ksles=$1 if ($kstring =~ /\-\d+\.(\d+)/mx);
    @f=split(/\W/m,$kstring);
    $platreqs = $rel->get_platreqs($prod);
    $platvers = join("\n\t",@{$platreqs});

    $localsys = Obj::localsys();
    $mediapath=EDR::get('mediapath');
    $tmpdir = EDR::tmpdir();
    $vmware = 0;
    $testVMware = "$mediapath/scripts/bin/testVMware";

    # Check ESX/KVM for AppHA, if vmware tools not installed or not running, quit installer 
    # For VCS in VMware environment, if vmware-tools not installed or not running, give warning
    if ($prod->{prod} =~ /ApplicationHA|VCS/) {
        $testVMware = "/opt/VRTSsfmh/bin/testVMware" unless ($localsys->exists($testVMware));
        if ($localsys->exists($testVMware)) {
            $localsys->copy_to_sys($sys,$testVMware,"$tmpdir/");
            $sys->cmd("$tmpdir/testVMware");
            if (EDR::cmdexit() == 0) {
                # it's VMware
                $sys->set_value('vmtype','vmware');
                $vmware = 1;

                @vmware_tool_scripts=('/etc/init.d/vmware-tools','/etc/vmware-tools/services.sh','/etc/init.d/vmware-tools-services');
                for my $script (@vmware_tool_scripts) {
                    if($sys->exists($script)) {
                        $vmware_script=$script;
                        last;
                    }
                }

                if ($vmware_script) {
                    $state = $sys->cmd("$vmware_script status 2> /dev/null");
                    # vmware-tools not running
                    if ($state =~ /not/i) {
                        # try to start it
                        $sys->cmd("$vmware_script start 2> /dev/null");
                        sleep 5;
                        $state = $sys->cmd("$vmware_script status 2> /dev/null");
                        if ($state =~ /not/i) {
                            $msg = Msg::new("vmware-tools is not running on $sys->{sys}, installer attempted to start it but failed. Please start the tool before installing $prod->{abbr}", 40, 6259, "$sys->{sys}", "$prod->{abbr}");
                            if ($prod->{prod} =~ /ApplicationHA/) {
                                $sys->push_error($msg);
                                return '';
                            } else {
                                $sys->push_warning($msg);
                            }
                        }
                    }
                } else {
                    $msg = Msg::new("The installer did not detect vmware-tools installed on $sys->{sys}, install vmware-tools and start it before you perform any task on $prod->{abbr}", 40, 6260, "$sys->{sys}", "$prod->{abbr}");
                    if ($prod->{prod} =~ /ApplicationHA/) {
                        $sys->push_error($msg);
                        return '';
                    } else {
                        $sys->push_warning($msg);
                    }
                }
            }
        } else {
            if ($prod->{prod} =~ /ApplicationHA/) {
                $msg = Msg::new("The installer cannot detect if you are running under VMware environment on $sys->{sys}, it is required to install $prod->{prod} under the VMware or the KVM environment.", 40, 6261, "$sys->{sys}", "$prod->{prod}");
                $sys->push_warning($msg); 
            }
            # if installer do NOT have testVMware utility, print a warning but pass the check
            $vmware = 1;
        }

        # AppHA only support to be installed on VMware VM, and KVM on RHEL,
        # do not support to be installed on physical systems, or KVM on OEL/SuSE
        if (!$vmware && $prod->{prod} =~ /ApplicationHA/) {
            if ($sys->{virtual_type} =~ /KVM/i) {
                if ($distro ne 'RHEL') {
                    $msg=Msg::new("$prod->{prod} for KVM does not support to be installed to OEL and SuSE.", 40, 5518, "$prod->{prod}");
                    $sys->push_error($msg);
                    return '';
                }
            } else {
                $msg=Msg::new("The installer cannot detect if you are running under KVM environment on $sys->{sys}, it is required to install $prod->{prod} under the VMware or the KVM environment.", 40, 6262, "$sys->{sys}", "$prod->{prod}");
                $sys->push_warning($msg);
            }
        }
    }

    if ($distro eq 'RHEL') {
        $padv->{cmd}{selinuxenabled}='/usr/sbin/selinuxenabled';
        if ($kstring =~ /el6/m) {
            return '' unless $rel->verify_os_update_sys($sys, $kstring, $distro, $platvers);
        } elsif ($kstring =~ /el5/m) {
            return '' unless $rel->verify_os_update_sys($sys, $kstring, $distro, $platvers);
        } else {
            $msg=Msg::new("Kernel Release $kstring found on $sys->{sys} is not supported, please use a distribution kernel.", 40, 6263, "$kstring", "$sys->{sys}");
            $sys->push_stop_checks_error($msg);
            return '';
        }

    } elsif ($distro eq 'SLES') {
        $padv->{cmd}{selinuxenabled}='/usr/bin/selinuxenabld';
        return '' unless $rel->verify_os_update_sys($sys, $kstring, $distro, $platvers);
    } elsif ($distro eq 'ESX') {
        # FIX: Figure this check out later for VMWARE. (Get versions of ESX supported and edit)
        if ($kret < 34) {
            $msg=Msg::new("Kernel Release $kstring is not supported on $sys->{sys}. Only Kernel Release 2.6.9-34.EL or higher is supported on RHEL.", 40, 3992, "$kstring", "$sys->{sys}");
            $sys->push_stop_checks_error($msg);
            return '';
        }
    } elsif ($distro eq 'OL') {
        # FIX: Figure this check out later for Oracle Linux.
        $padv->{cmd}{selinuxenabled}='/usr/sbin/selinuxenabled';
        if ($kstring =~ /el6/m) {
            # OL6 check
            if ($kstring =~ /uek/m || $kstring !~ /^2\.6\.32/m) {
                $msg=Msg::new("Kernel Release $kstring found on $sys->{sys} is not supported. Only Red Hat compatible Kernel Release 2.6.32 is supported on Oracle Linux 6. you may configure the operating system to boot with this kernel instead.", 40, 4784, "$kstring", "$sys->{sys}");
                $sys->push_stop_checks_error($msg);
                return '';
            }
        } elsif ($kstring =~ /el5/m) {
            # OL5 check
            if ($kstring =~ /uek/m || $kstring !~ /^2\.6\.18/m) {
                $msg=Msg::new("Kernel Release $kstring found on $sys->{sys} is not supported. Only Red Hat compatible Kernel Release 2.6.18 is supported on Oracle Linux 5. you may configure the operating system to boot with this kernel instead.", 40, 4785, "$kstring", "$sys->{sys}");
                $sys->push_stop_checks_error($msg);
                return '';
            }
        }
    } else {
        $msg=Msg::new("Distribution is not recognized as SuSE or Red Hat on $sys->{sys}", 40, 3993, "$sys->{sys}");
        $sys->push_stop_checks_error($msg);
        return '';
    }

    # XEN is not supported in 6.0
    if ($kstring =~ /xen/m) {
        $msg=Msg::new("Kernel Release on $sys->{sys} is $kstring. Xen kernel is not supported in this release.", 40, 4890, "$sys->{sys}", "$kstring");
        $sys->push_stop_checks_error($msg);
        return '';
    }

    # Distribution match on all systems removed as any to many support is added
    for my $pkgi (@{$rel->allpkgs}) {
        $pkg=$sys->pkg($pkgi);
        push(@pkg_files,$pkg->{file});
    }

    if (@pkg_files) {
       return 1 if ($cpic->{fromdisk});
       $rpm_dir=$rel->pkgs_patches_dir('pkgpath');;
       if ((($sys->{arch}=~/686/m)||($sys->{arch}=~/586/m)) && (grep {/86_64/m} @pkg_files)) {
            $msg=Msg::new("System $sys->{sys} is architecture $sys->{arch} and x86_64 rpms were found in $rpm_dir. Check that you are installing from the correct DVD. Some rpms will not install correctly on this system.", 40, 3626, "$sys->{sys}", "$sys->{arch}", "$rpm_dir");
            $sys->push_stop_checks_error($msg);
            return '';
        }

       if ((($distro eq 'RHEL') && (grep {/SLES/} @pkg_files))
            ||  (($distro eq 'SLES') && (grep {/RHEL/} @pkg_files))) {
            $msg=Msg::new("System $sys->{sys} is distribution $distro and incompatible rpms were found in $rpm_dir. Check that you are installing from the correct DVD. Some rpms will not install correctly on this system.", 40, 3627, "$sys->{sys}", "$distro", "$rpm_dir");
            $sys->push_stop_checks_error($msg);
            return '';
       }
    }

    # No need for selinux checks any more
    return 1;
}

sub verify_os_update_sys {
    my ($rel, $sys, $kstring, $distro, $platvers) = @_;
    my ($os_update, $os_update_min, $os_update_max, $os_update_err);
    my ($cpic, $sort_padv, $sort_kernel, $required_patch_id, $msg);
    
    $cpic=Obj::cpic();
    $os_update_min     = $rel->{os_update_min};
    $os_update_max     = $rel->{os_update_max};
    $os_update_err     = $rel->{os_update_err};
    $sort_padv         = $rel->{sort_padv};
    $sort_kernel       = $rel->get_sort_kernel($kstring, $sort_padv);
    $os_update         = $rel->{kernel_padv}{$sort_padv}{$sort_kernel};    
    $required_patch_id = $rel->{os_update_patchid_mapping}{$os_update};

    Msg::log("OS update level of $sys->{sys}: $os_update");
    Msg::log("Required patch id: $required_patch_id") if ($required_patch_id);

    if ( defined($os_update_err) && ($os_update >= $os_update_err) ) {
        $msg=Msg::new("Kernel Release $kstring is detected on $sys->{sys}, which is not supported for this product. The supported Kernel Releases are:\n\t$platvers", 40, 6264, "$kstring", "$sys->{sys}", "$platvers");
        $sys->push_stop_checks_error($msg);
        return 0;                            	
    } elsif ($os_update < $os_update_min) {
        $msg=Msg::new("Kernel Release $kstring is detected on $sys->{sys}, which is not supported for this product. The supported Kernel Releases are:\n\t$platvers", 40, 6264, "$kstring", "$sys->{sys}", "$platvers");
        $sys->push_stop_checks_error($msg);
        return 0;
    } elsif ($os_update > $os_update_max) {
        if ($cpic->{sortready}) { 
            $msg = Msg::new("Kernel Release $kstring is detected on $sys->{sys}, which is not supported for this product.", 40, 6265, "$kstring", "$sys->{sys}");
        } else {
            $msg = Msg::new("Kernel Release $kstring is detected on $sys->{sys}. Additional patches may be required to deploy this product on the Kernel Release $kstring. It is strongly recommended to check it on SORT (https://sort.symantec.com) before continue.", 40, 6266, "$kstring", "$sys->{sys}", "$kstring");	
        }
        $sys->push_warning($msg);
    } else { # os_update_err is undefined and $os_update is between [$os_update_min..$os_update_max]
        # Check if there is patch required on this os update and not been included in this execution
        if ( $required_patch_id && $rel->must_have_patch_sys($sys,$required_patch_id) ) {
            $sys->set_value('must_have_patch',$required_patch_id);
        } else {
            # When prod_prerequisites has required OS lib, CPI will recommend to install the OS lib with YUM
            # After Yum installation, pre-check will be re-executed, need to re-set this value to avoid it download again
            $sys->set_value('must_have_patch',undef);
        }
    }
    
    return 1; # yeah! no errors!	
}

package Prod::VCS61::Common;

sub maincf_upgrade_precheck_sys {
    my ($prod,$sys,$vcsvers) = @_;
    my ($rootpath,$vcspkg,$msg,$unfreeze_sg,$grp,@grp_syslist,$cmd_hacf,@grps,$delete_cmc,$treeref_olduser,@extra_types,$attrs,$vxss_autostartlist,$upgradepath,$sfua_delete_SfuaBase,$line,$rtn,$delete_VCSweb,$grp_syslists,$vxss_add_autostartlist);

    $rootpath = Cfg::opt('rootpath') || '';
    $upgradepath= EDR::tmpdir().'/upgrade';
    $cmd_hacf = $prod->{cmd_hacf};

    # Use hacf on ABE only if the OS on PBE is same with ABE.
    if ($rootpath) {
        my @uname = split(/\s+/m,$sys->{uname});
        if ($sys->{platvers} eq $uname[2]) {
            $cmd_hacf= "$rootpath$prod->{bindir}/hacf";
            $prod->set_value('cmd_hacf',$cmd_hacf);
        } else {
            $sys->set_value('osupgraded',1);
        }
    }

    if ($sys->system1) {
        # dump vcs configuraton
        if (!Cfg::opt('rootpath') && !$prod->{upgrade_ignore_conf} && $sys->{prod_running}) {
            $prod->haconf_makerw();
            $prod->haconf_dumpmakero();
        }

        if (!$vcsvers) {
            $vcspkg=$prod->pkg('VRTSvcs61');
            $vcsvers=$vcspkg->version_sys($sys) if (defined $vcspkg);
        }

        unless ($prod->dynupgrade_pre_upgrade_sys($sys,$vcsvers)) {
            EDRu::create_flag('maincf_upgrade_precheck_done');
            return 0;
        }

        # create cmd list
        $treeref_olduser = dynupgrade_import_file2tree_sys($sys, "$rootpath$prod->{configdir}/main.cmd");

        $prod->maincf_check_TriggerResStateChange_sys($sys,$treeref_olduser,$vcsvers);

        # Update PreOnline attribute.
        $prod->maincf_preonline_precheck_sys($sys,$treeref_olduser,$vcsvers);

        # vip will only bu updated for upgrade from less6.0 to 6.0 onwards
        $prod->maincf_precheck_if_update_vip_sys($sys,$vcsvers);

        # Change sourcefile path for types/service groups to config dir
        modify_sourcefile_sys($sys,$treeref_olduser,'GRP');
        unless ($prod->dynupgrade_pre_customize_changed_types_sys($sys,$treeref_olduser,$upgradepath)) {
            EDRu::create_flag('maincf_upgrade_precheck_done');
            return 0;
        }
        my $sourcefiles= modify_sourcefile_sys($sys,$treeref_olduser,'TYPE');
        dynupgrade_export_tree2file_sys( $sys, "$upgradepath/old_config/main.cmd", $treeref_olduser);
        $prod->translate_file_cmd2cf_sys( $sys, "$upgradepath/old_config");

        # Copy types for VRTSvcsea and VRTSdbac to old_conf;
        my ($extra_type,$extra_type_base,$pkg,$pkgi);
        for my $pkgi (qw(VRTSvcsea61 VRTSdbac61)) {
            $pkg = $prod->pkg($pkgi,1);
            next unless (defined $pkg);
            push (@extra_types,@{$pkg->{extra_types}});
        }
        for my $extra_type (@extra_types,@{$prod->{extra_types}}) {
            $extra_type_base = EDRu::basename($extra_type);
            if (EDRu::inarr($extra_type_base, @{$sourcefiles})) {
	        if ($sys->exists("$extra_type") && !$sys->exists("$upgradepath/old_conf/$extra_type_base")){
	            $sys->cmd("_cmd_cp -p $extra_type $upgradepath/old_conf");
	        }
                $sys->set_value("maincf_include,$extra_type_base", $extra_type_base);
            }
        }

        unless ($prod->maincf_check_obsolete_types_sys($sys,$treeref_olduser,$vcsvers)) {
            EDRu::create_flag('maincf_upgrade_precheck_done');
            return 0;
        }

        my $panic_system_on_dg_loss_attr = dynupgrade_get_attrvalue_of_typename($treeref_olduser,'DiskGroup','PanicSystemOnDGLoss');
        if ($panic_system_on_dg_loss_attr eq '1') {
            my @reslist=dynupgrade_get_resname_list_from_typename($treeref_olduser, 'DiskGroup');
            if (@reslist) {
                $msg = Msg::new("The default value of the DiskGroup agent attribute, PanicSystemOnDGLoss, will be changed from 1 to 0 after an upgrade. Refer to the Symantec Cluster Server Bundled Agents Reference Guide for the implications of this change.");
                $sys->push_warning($msg);
            }
        }

        $prod->maincf_upgrade_cvm_cfs_types_sys($sys,$treeref_olduser,$vcsvers);

        @grps=dynupgrade_get_grplist($treeref_olduser);

        # Add AutoStartList to VxSS Service Group if it is not defined.
        if (EDRu::inarr('VxSS',@grps)) {
            $vxss_autostartlist = dynupgrade_get_attr_from_tree($treeref_olduser,'GRP','VxSS','AutoStartList');
            unless ($vxss_autostartlist) {
                @grp_syslist = dynupgrade_get_systemlist_of_grpname($treeref_olduser,'VxSS');
                $grp_syslists = join (' ', @grp_syslist);
                $vxss_add_autostartlist = "hagrp -modify VxSS AutoStartList $grp_syslists";
                $sys->set_value('maincf_upgrade,21_vxss_add_autostartlist', $vxss_add_autostartlist);
            }
        }

        # Update DNS ResRecord.
        my $dns_resrecord = dynupgrade_modify_attr_value_DNS($treeref_olduser);
        if ($dns_resrecord) {
            $sys->set_value('maincf_upgrade,30_dns_resrecord', $dns_resrecord);
        }

        #remove service group.
        #Add 99_ prefix to make sure the delete operation is added to the end.
        $sfua_delete_SfuaBase='hagrp -delete Sfua_Base';
        $sys->set_value('maincf_upgrade,99_sfua_delete_SfuaBase', $sfua_delete_SfuaBase);
        $delete_cmc='hagrp -delete CMC';
        $sys->set_value('maincf_upgrade,99_delete_CMC', $delete_cmc);

        $delete_VCSweb='hares -delete VCSweb';
        $sys->set_value('maincf_upgrade,99_delete_VCSweb', $delete_VCSweb);

        $prod->padv_maincf_upgrade_precheck_sys($sys,$treeref_olduser,$vcsvers);
        $prod->padv_maincf_update_netmask_sys($sys,$treeref_olduser,$vcsvers);

        EDRu::create_flag('maincf_upgrade_precheck_done');
    } else {
        EDRu::wait_for_flag('maincf_upgrade_precheck_done');
    }
    return 1;
}

sub maincf_upgrade_cvm_cfs_types_sys {
    my ($prod,$sys,$treeref_olduser,$vcsvers) = @_;
    my ($attr_node,$cfsmount_attr,$type_node,$attr_name,$type_name,$rtn,$cvmvoldg_reglist,$cvmvoldg_arglist);
    my ($cvmcluster_reglist,$cvmcluster_attr,$cvmcluster_arglist);

    # Update CFSMount
    # Add AMFMountType as a attr to CFSMount in 5.1SP1
    $type_name = 'CFSMount';
    if ($type_node = dynupgrade_get_node_from_tree( $treeref_olduser, 'TYPE', $type_name)) {
        $attr_name = 'AMFMountType';
        $attr_node = dynupgrade_get_node_from_tree( $type_node, 'ATTR', $attr_name);
        # do nothing if AMFMountType already exist
        unless ($attr_node) {
            $cfsmount_attr = 'haattr -add -temp CFSMount AMFMountType -string';
            $sys->set_value('maincf_upgrade,10_cfsmount_add', $cfsmount_attr);
        }
    }

    # Update CFSMount
    # Add Primary to ArgList in CFSMount in 5.1
    # Add AMFMountType to ArgList in CFSMount in 5.1SP1
    $rtn = dynupgrade_get_attrvalue_of_typename($treeref_olduser,'CFSMount','ArgList');
    if ($rtn) {
        $rtn .= ' Primary' if ($rtn!~/Primary/m);
        $rtn .= ' AMFMountType' if ($rtn!~/AMFMountType/m);
        $cfsmount_attr="hatype -modify CFSMount ArgList $rtn";
        $sys->set_value('maincf_upgrade,10_cfsmount_attr', $cfsmount_attr);
    }

    # Update CVMVolDg
    # Add CVMVolume to RegList in CVMVolDg in 5.1
    $rtn = dynupgrade_get_attrvalue_of_typename($treeref_olduser,'CVMVolDg','RegList');
    if ($rtn) {
        $rtn .= ' CVMVolume' if ($rtn!~/CVMVolume/m);
        $cvmvoldg_reglist="hatype -modify CVMVolDg RegList $rtn";        $rtn .= ' CVMVolumeIoTest' if ($rtn!~/CVMVolumeIoTest/m);
        $rtn .= ' CVMDGAction' if ($rtn!~/CVMDGAction/m);
        $rtn .= ' CVMDeportOnOffline' if ($rtn!~/CVMDeportOnOffline/m);
        $rtn .= ' CVMDeactivateOnOffline' if ($rtn!~/CVMDeactivateOnOffline/m);
        $rtn .= ' State' if ($rtn!~/State/m);
        $rtn .= ' ClearClone' if ($rtn!~/ClearClone/m);
        $cvmvoldg_arglist="hatype -modify CVMVolDg ArgList $rtn\n";
        $cvmvoldg_arglist.="haattr -add CVMVolDg CVMVolumeIoTest -keylist\n";
        $cvmvoldg_arglist.="hatype -modify CVMVolDg OnlineRetryLimit 2\n";
        $cvmvoldg_arglist.="hatype -modify CVMVolDg OnlineTimeout 400\n";
        $cvmvoldg_arglist.="haattr -add CVMVolDg CVMDGAction -string\n";
        $cvmvoldg_arglist.="haattr -add CVMVolDg CVMDeportOnOffline -integer\n";
        $cvmvoldg_arglist.="haattr -add CVMVolDg CVMDeactivateOnOffline -integer\n";
        $cvmvoldg_arglist.="haattr -add CVMVolDg ClearClone -integer";
        $sys->set_value('maincf_upgrade,11_cvmvoldg_arglist', $cvmvoldg_arglist);
    }

    # Update CVMCluster
    $type_name = 'CVMCluster';
    if ($type_node = dynupgrade_get_node_from_tree( $treeref_olduser, 'TYPE', $type_name)) {
        # Add CVMNodePreference as an attr to CVMCluster in 6.0.1
        $attr_name = 'CVMNodePreference';
        $attr_node = dynupgrade_get_node_from_tree( $type_node, 'ATTR', $attr_name);
        # do nothing if CVMNodePreference already exist
        $cvmcluster_attr.="haattr -add CVMCluster CVMNodePreference -string\n" unless ($attr_node);

        # Add CVMClus_storage_connectivity as an attr to CVMCluster in 6.0.1
        $attr_name = 'CVMClus_storage_connectivity';
        $attr_node = dynupgrade_get_node_from_tree( $type_node, 'ATTR', $attr_name);
        # do nothing if CVMClus_storage_connectivity already exist
        $cvmcluster_attr.='haattr -add CVMCluster CVMClus_storage_connectivity -keylist' unless ($attr_node);
        $sys->set_value('maincf_upgrade,12_cvmcluster_add', $cvmcluster_attr) if ($cvmcluster_attr);

        # Add CVMNodePreference to RegList in 6.0.1
        # Add CVMClus_storage_connectivity to RegList and ArgList in 6.0.1
        $rtn = dynupgrade_get_attrvalue_of_typename($treeref_olduser,'CVMCluster','RegList');
        if ($rtn) {
            $rtn .= ' CVMNodePreference' if ($rtn!~/CVMNodePreference/m);
            $rtn .= ' CVMClus_storage_connectivity' if ($rtn!~/CVMClus_storage_connectivity/m);
            $cvmcluster_reglist="hatype -modify CVMCluster RegList $rtn";
            $sys->set_value('maincf_upgrade,12_cvmcluster_reglist', $cvmcluster_reglist);
        } else {

        $sys->set_value('maincf_upgrade,11_cvmvoldg_reglist', $cvmvoldg_reglist);
    }
    # Add CVMVolumeIoTest, CVMDGAction to ArgList in CVMVolDg in 5.1
    # Add CVMDeportOnOffline to ArgList in CVMVolDg in 5.1SP1
    # Add CVMDeactivateOnOffline to ArgList in CVMVolDg in 6.0.1
    $rtn = dynupgrade_get_attrvalue_of_typename($treeref_olduser,'CVMVolDg','ArgList');
    if ($rtn) {
            # should not add this line if no CVMTypes
            $cvmcluster_reglist='haattr -add -static CVMCluster RegList  -keylist CVMNodePreference CVMClus_storage_connectivity';
            $sys->set_value('maincf_upgrade,12_cvmcluster_reglist', $cvmcluster_reglist);
        }
        $rtn = dynupgrade_get_attrvalue_of_typename($treeref_olduser,'CVMCluster','ArgList');
        if (($rtn) && ($rtn!~/CVMClus_storage_connectivity/m)) {
            $rtn .= ' CVMClus_storage_connectivity';
            $cvmcluster_arglist="hatype -modify CVMCluster ArgList $rtn";
            $sys->set_value('maincf_upgrade,12_cvmcluster_arglist', $cvmcluster_arglist);
        }
    }

    return;
}

package Prod;

sub cli_print_requirements {
    my ($prod) = @_;
    my ($otherreqs,$prodspace,$minspace,$rel,$msg,$platreqs,$platreqs_str,$ps,$ms,$recspace,@space,$cs,$prodname,$pkg,$pkgspace);
    $rel=$prod->rel;
    
    $rel->pre_platvers();

    $prodname = $prod->{name};
    $msg=Msg::new("The requirements for product '$prodname':\n", 30, 2064, "$prodname");
    $msg->print;

    $platreqs = $rel->get_platreqs($prod);
    if (defined $platreqs) {
        $platreqs_str=join("\n",@{$platreqs});
        $msg=Msg::new("Required OS/Kernel Versions:\n$platreqs_str", 30, 2660, "$platreqs_str");
        $msg->print;
    }

    $prod->cli_print_os_dependency();

    if ($prod->{minimal_memory_requirment}) {
        $msg=Msg::new("\nMinimal Memory Required: $prod->{minimal_memory_requirment}", 30, 2065, "$prod->{minimal_memory_requirment}");
        $msg->print;
    }

    # Determine the space requirement for the product
    for my $pkgi (@{$prod->get_pkgs}) {
        $pkg=$prod->pkg($pkgi);
        $pkg->{space} = $pkg->space();
        $pkg->{space}||=[100,100,100,100];
        @space=@{$pkg->{space}};
        $pkgspace=$space[0]+$space[1]+$space[2]+$space[3];
        $prodspace+=$pkgspace;
        if (EDRu::inarr($pkgi,@{$prod->minpkgs})) {
            $minspace+=$pkgspace;
        }
        if (EDRu::inarr($pkgi,@{$prod->recpkgs})) {
            $recspace+=$pkgspace;
        }
    }
    $ms=int($minspace/1024);
    $cs=int($recspace/1024);
    $ps=int($prodspace/1024);
    $msg=Msg::new("\nSpace Requirements:\n$prod->{abbr} Minimum Package Set - $ms MB\n$prod->{abbr} Recommended Package Set - $cs MB\n$prod->{abbr} All Package Set - $ps MB", 30, 1994, "$prod->{abbr}", "$ms", "$prod->{abbr}", "$cs", "$prod->{abbr}", "$ps");
    $msg->print;

    $otherreqs=$prod->other_requirements||'';
    unless ($otherreqs){
        $otherreqs = Msg::new("None", 30, 1814)->{msg};
    }

    $msg=Msg::new("\nOther Requirements:\n$otherreqs", 30, 1995, "$otherreqs");
    $msg->print;

    return '';
}

package CPIC;

sub add_mr {
    my ($cpic, $arg) = (@_);
    $cpic->{mr} = '';
    $cpic->{mrobj} = '';
    my $mr = $cpic->maintenance_version if ($cpic->can("maintenance_version"));
    if (($mr) && (!$cpic->{mr_arg}{$mr})) {
        $cpic->{mr} = $mr; 
    }
    return;
}

sub ask_install {
    my $cpic=shift;
    my ($ayn,$cfg,$msg,$prod,$systems,$continue,$rel);
    $prod=$cpic->prod;
    $cfg=Obj::cfg();
    $rel=Obj::rel();
    $systems = join(' ',@{$cfg->{systems}});
    if (Cfg::opt('upgrade')) {
        $msg=Msg::new("Would you like to upgrade $prod->{abbr} on $systems?", 30, 1984, "$prod->{abbr}", "$systems");
    } else {
        $msg=Msg::new("Would you like to install $prod->{abbr} on $systems?", 30, 1985, "$prod->{abbr}", "$systems");
    }
    $ayn=$msg->aynn();
    
    if ($ayn eq 'Y') {
        $continue = 1;
        # down required path if users choose to go on
        if ($rel->{required_patch_id}) {
            $continue = $cpic->install_must_have_patch($rel->{required_patch_id});
        }
    }

    Msg::n();
    return $continue;
}

sub create_cpip_objects {
    my ($cpic,$padv) = @_;
    my ($rel,$patch,$pkglist,@pkgs,$pkg,$prod,$hotfix);
    if (!EDRu::inarr($padv, @{EDR::padvs()}, 'Common')) {
        # import anything to operate the rest of the commands OK
        # unsupported padvs will eventually die later
        Msg::log("create_cpip_objects: $padv is not a supported platform");
        return;
    } elsif ($Obj::pool{"Rel\::$cpic->{release}\::$padv"}) {
        #Msg::log("$cpic->{release} $padv CPIP objects already created");
        return $cpic->rel($padv);
    }
    #Msg::log("Creating $cpic->{release}::$padv CPIP objects");
    $rel=$cpic->{rel}{$padv}=init_cpip_object("Rel::$cpic->{release}",$padv);
    push(@pkgs, @{$rel->allpkgs});
    for my $prodv (@{$rel->{prods}}) {
        $prod=init_cpip_object("Prod::$prodv",$padv);
        $prod->{release}=$cpic->{release};
        $prod->set_pkgs;
        push(@pkgs, @{$prod->allpkgs_on_media});
        for my $subprodv(@{$prod->{subprods}}) {
            my $subprod=init_cpip_object("Prod::$subprodv",$padv);
            $subprod->{release}=$cpic->{release};
            push(@pkgs, @{$subprod->allpkgs_on_media});
        }
    }

    $pkglist=EDRu::arruniq(@pkgs);
    for my $pkgi (@{$pkglist}) {
        $pkg=init_cpip_object("Pkg::$pkgi",$padv);
        for my $proc (@{$pkg->allprocs}) { init_cpip_object("Proc::$proc",$padv); }
        for my $prevpkgname (@{$pkg->{previouspkgnames}}) {
            Pkg->new_pkg($prevpkgname, $padv);
        }
    }

    $cpic->add_mr();
    if ($cpic->{mr}) {
        my $mr = init_cpip_object("MR::$cpic->{mr}", $padv);
        $mr->define_patches();
        $cpic->{mrobj} = $mr; 
    }  

    $cpic->add_hotfix;
    for my $hfi(@{$cpic->{hotfixes}}) {
        $hotfix=init_cpip_object("Hotfix::$hfi",$padv);
        push(@{$cpic->{hotfixobj}}, $hotfix);
        # must correlate the hotfix to the arg used to import it
        # initialized patches receive this def in order to determine the correct mediapath
        $hotfix->{arg}=$cpic->{hotfix_arg}{$hfi} if (defined($cpic->{hotfix_arg}{$hfi}));
        $hotfix->define_patches();
    }

    $rel->define_patches();
    for my $pkgi (@{$pkglist}) {
        $pkg=Obj::pkg($pkgi, $padv);
        for my $patchi (@{$pkg->patches_allvers}) {
            # Patches are not built-in defined in CPIP, create it.
            $patch=new_object("Patch::$patchi",$padv);
            $patch->{pkg}=$pkgi;
            # was this patch initialized using base_path or a hotfix_path
            # if so we need to reference a different mediapath
            $patch->{arg}=$rel->{patcharg}{$patchi} if (defined($rel->{patcharg}{$patchi}));
        }
    }
    #$cpic->create_eeb_objects($rel,$padv) if ($rel->{reli}=~/^EEB/);
    $rel->adjust_pkglist();
    # initiate release matrix
    $cpic->rel->initiate_kernel_padv_hash();
    $cpic->rel->init_sort_platvers();
    return $rel;
}

sub setup_verify_systems_phase {
    my ($cpic, $check_com_only) = @_;
    my ($edr,$rel,$phase,$desc,$task,$task_name,%task_params,$pdfrs,$id);
    my ($skip_prerequisite,$skip_fsspace,$skip_license,$skip_platvers);

    $cpic->{falsefailures}=0;
    $phase= Phase->new('CPIC_prechecks');

    # Directly return $phase if it is already created.
    return $phase if (defined $phase->{description});

    $desc = Msg::new("Verifying systems", 30, 2152);
    $phase->set_description($desc);
    $phase->set_fatal_error_key('stop_checks');
    $phase->initialize_tasks();

    $edr=Obj::edr();
    $rel=$cpic->rel();
    $pdfrs=Msg::get('pdfrs');

    # By default, skip product version/license checking,
    # skip patches checking, skip file system space checking
    $skip_prerequisite=1;
    $skip_fsspace=1;
    $skip_license=1;

    # if install/upgrade task specified, then run above checkings.
    if (install_check_task()) {
        $skip_prerequisite=0;
        $skip_fsspace=0;
        $skip_license=0;
    }
    if ($rel->rollback_check_task()) {
        $skip_fsspace=0;
    }
    $skip_fsspace=1 if (Cfg::opt('nospacecheck'));
    $skip_license=1 if (!$rel->can("read_licenses_sys"));
    $skip_platvers=1 if (Cfg::opt('uninstall'));
    
    $id=100;
    $task_name='edr_check_communication';
    %task_params= (
        'sequence_id' => $id,
        'description' => Msg::new("Checking system communication", 30, 2364),
        'description_sys' => Msg::new("Checking communication on #{SYS}", 30, 2365),
        'if_per_system' => 1,
        'handler' => \&EDR::transport_sys,
        'handler_object_arg' => $edr,
        'post_handler' => \&CPIC::post_transport,
        'post_handler_object_arg' => $cpic,
        'error_handler' => \&CPIC::transport_error_handler,
        'error_handler_object_arg' => $cpic,
    );
    $task=Task->new($task_name, %task_params);
    $phase->add_task($task);

    return $phase if ($check_com_only);

    $id+=100;
    $task_name='edr_check_release_compatibility';
    %task_params= (
        'sequence_id' => $id,
        'description' => Msg::new("Checking release compatibility", 30, 2366),
        'description_sys' => Msg::new("Checking release compatibility on #{SYS}", 30, 2367),
        'if_per_system' => 1,
        'handler' => \&EDR::supported_padv_sys,
        'handler_object_arg' => $edr,
    );
    $task=Task->new($task_name, %task_params);
    $phase->add_task($task);

    $id+=100;
    $task_name='cpic_check_installed_product';
    %task_params= (
        'sequence_id' => $id,
        'description' => Msg::new("Checking installed product", 30, 1291),
        'description_sys' => Msg::new("Checking installed product on #{SYS}", 30, 2368),
        'if_per_system' => 1,
        'handler' => \&CPIC::installed_prod_info_sys,
        'handler_object_arg' => $cpic,
        'post_handler' => \&CPIC::post_installed_prod_info,
        'post_handler_object_arg' => $cpic,
    );
    $task=Task->new($task_name, %task_params);
    $phase->add_task($task);

    $id+=100;
    $task_name='cpic_check_platform_version';
    %task_params= (
        'sequence_id' => $id,
        'description' => Msg::new("Checking platform version", 30, 1293),
        'description_sys' => Msg::new("Checking platform version on #{SYS}", 30, 2370),
        'if_per_system' => 1,
        'skip' => $skip_platvers,
        'pre_handler' => \&CPIC::pre_rel_platvers,
        'pre_handler_object_arg' => $cpic,
        'handler' => \&CPIC::rel_platvers_sys,
        'handler_object_arg' => $cpic,
        'post_handler' => \&CPIC::post_rel_platvers,
        'post_handler_object_arg' => $cpic,
        'error_handler' => \&CPIC::rel_platvers_error_handler,
        'error_handler_object_arg' => $cpic,
    );
    $task=Task->new($task_name, %task_params);
    $phase->add_task($task);

    $id+=100;
    $task_name='cpic_check_prerequisite_packages_patches';
    %task_params= (
        'sequence_id' => $id,
        'description' => Msg::new("Checking prerequisite patches and $pdfrs", 30, 1900, "$pdfrs"),
        'description_sys' => Msg::new("Checking prerequisite patches and $pdfrs on #{SYS}", 30, 2369, "$pdfrs"),
        'if_per_system' => 1,
        'skip' => $skip_prerequisite,
        'handler' => \&CPIC::prod_prerequisite_sys,
        'handler_object_arg' => $cpic,
        'post_handler' => \&CPIC::post_prod_prerequisite,
        'post_handler_object_arg' => $cpic,
        'error_handler' => \&CPIC::prod_prerequisite_error_handler,
        'error_handler_object_arg' => $cpic,
    );
    $task=Task->new($task_name, %task_params);
    $phase->add_task($task);
    
    $id+=100;
    $task_name='cpic_check_filesystem_free_space';
    %task_params= (
        'sequence_id' => $id,
        'description' => Msg::new("Checking file system free space", 30, 2158),
        'description_sys' => Msg::new("Checking file system free space on #{SYS}", 30, 2371),
        'if_per_system' => 1,
        'skip' => $skip_fsspace,
        'handler' => \&CPIC::fsspace_sys,
        'handler_object_arg' => $cpic,
    );
    $task=Task->new($task_name, %task_params);
    $phase->add_task($task);

    $id+=100;
    $task_name='cpic_check_product_license';
    %task_params= (
        'sequence_id' => $id,
        'description' => Msg::new("Checking product licensing", 30, 2159),
        'description_sys' => Msg::new("Checking product licensing on #{SYS}", 30, 2372),
        'if_per_system' => 1,
        'skip' => $skip_license,
        'handler' => \&CPIC::prod_licenses_sys,
        'handler_object_arg' => $cpic,
        'post_handler' => \&CPIC::post_prod_licenses,
        'post_handler_object_arg' => $cpic,
    );
    $task=Task->new($task_name, %task_params);
    $phase->add_task($task);

    $id+=100;
    $task_name='cpic_perform_product_prechecks';
    %task_params= (
        'sequence_id' => $id,
        'description' => Msg::new("Performing product prechecks", 30, 1296),
        'description_sys' => Msg::new("Performing product prechecks on #{SYS}", 30, 2373),
        'if_per_system' => 1,
        'pre_handler' => \&CPIC::pre_prod_precheck,
        'pre_handler_object_arg' => $cpic,
        'handler' => \&CPIC::prod_precheck_sys,
        'handler_object_arg' => $cpic,
        'post_handler' => \&CPIC::post_prod_precheck,
        'post_handler_object_arg' => $cpic,
        'error_handler' => \&CPIC::prod_precheck_error_handler,
        'error_handler_object_arg' => $cpic,
    );
    $task=Task->new($task_name, %task_params);
    $phase->add_task($task);

    return $phase;
}

sub pre_rel_platvers {
    my $cpic=shift;
    return $cpic->rel->pre_platvers();
}

sub rel_platvers_error_handler {
    my $cpic=shift;
    my ($rel,$syslist,$sys0,$padv,$msg,$patches,$rtn,$required_patch_id,$required_patch);

    $rel = $cpic->rel();
    $padv = $rel->{sort_padv};
    $syslist = CPIC::get('systems');
    $sys0 = $$syslist[0];

    for my $sys(@$syslist) {
        if ($sys->{must_have_patch}) {
            $required_patch_id = $sys->{must_have_patch} if ($sys->{must_have_patch} > $required_patch_id);
        }
    }
    return unless $required_patch_id;
    $rel->set_value('required_patch_id',$required_patch_id);

    Msg::n();
    $required_patch = $cpic->rel->{release_matrix}{$padv}{'hotfix'}{$required_patch_id}{'release_name'};
    if (Cfg::opt('precheck')) {
        $msg=Msg::new("The following patch for InfoScale product is required:\n\t$required_patch", 30, 2635, "$required_patch");
        $sys0->push_note($msg);
    } else {
        $msg=Msg::new("The following patch for InfoScale product will be downloaded and installed:\n\t$required_patch", 30, 2636, "$required_patch");
        $msg->print;
        $rtn=$cpic->install_must_have_patch($required_patch_id);
    }

    return 1;
}

sub install_must_have_patch {
    my ($cpic,$required_patch_id) =@_;
    my ($patch_path,$padv,$msg,$rtn);
    
    $patch_path = $cpic->download_must_have_patch($required_patch_id);
    return 0 if (!$patch_path);
    $rtn = $cpic->expand_must_have_patch($patch_path);
    return 0 if (!$rtn);
    $cpic->apply_must_have_patch($patch_path);

    return 1;
}

# to download must have patch
sub download_must_have_patch {
    my ($cpic,$required_patch_id) = @_;
    my ($url,$sys0,$dir,$filename,$release_name,$rtn,$file,$msg,$download_errors,$sort_hotfix,$padv);

    $padv = $cpic->rel->{sort_padv};
    $sort_hotfix = $cpic->rel->{release_matrix}{$padv}{'hotfix'}{$required_patch_id};
    $url = $sort_hotfix->{upload_location};
    return '' unless $url;
    
    $sys0 = ${CPIC::get('systems')}[0];
    $filename = $sort_hotfix->{filename};
    $release_name = $sort_hotfix->{release_name};
    # initiate $cpic->{required_patch_path} here for CPI hotfix
    $cpic->{required_patch_path}='/opt/VRTS/install/repository/required_patch';
    $dir = $cpic->{required_patch_path} . '/' . $release_name;
    $file = "$dir/$filename";
    # check if we can reuse the patch which has already been downloaded
    if (-f $file) {
        $rtn = $cpic->download_must_have_patch_cksum($required_patch_id,$dir);
        if ($rtn) {
            Msg::n();
            $msg = Msg::new("$release_name has already been downloaded.", 30, 2637, "$release_name");
            $msg->print();
            return $dir;
        }
    }
    # sort isn't ready and we don't have it locally
    if (!$cpic->{sortready}) {
        $msg = Msg::new("Failed to connect to SORT (https://sort.symantec.com), the patch $release_name is required to deploy this product.", 30, 2638, "$release_name");
        if (Cfg::opt('precheck')) {
            Msg::n();
            $msg->error;
            Msg::n();
        } else {
            $sys0->push_error($msg);
        }
        return ''
    }

    EDRu::mkdir_local_nosys($dir) || return '';
    Msg::n();
    $msg = Msg::new("Downloading required patch $release_name from SORT (https://sort.symantec.com)", 30, 2639, "$release_name");
    $msg->printn;
    $rtn=EDRu::download_file($url, $file, 1, 2);
    if (!$rtn || ! -f $file) {
        $download_errors=EDR::get('download_errors');
        Msg::log("Could not download file $file!\n\n$download_errors\n");
        EDRu::rmdir_local_nosys($dir);
        return '';
    }

    # check sum after downloading the patch
    $rtn = $cpic->download_must_have_patch_cksum($required_patch_id,$dir); 
    if ($rtn) {    
        Msg::log("Download required patch $release_name from SORT (https://sort.symantec.com) successfully.\n");
        return $dir;
    } else {
        $msg = Msg::new("Failed to download the required patch $release_name.", 30, 2640, "$release_name");
        $sys0->push_error($msg);
        return '';
    }
}

sub download_must_have_patch_cksum {
    my ($cpic,$required_patch_id,$dir) = @_;
    my ($padv,$filename,$file,$sort_hotfix,@cksum_size,$cksum,$size);

    $padv = $cpic->rel->{sort_padv};
    $sort_hotfix = $cpic->rel->{release_matrix}{$padv}{'hotfix'}{$required_patch_id};
    
    @cksum_size = ($sort_hotfix->{upload_cksum},$sort_hotfix->{upload_size});
    $filename = $sort_hotfix->{filename};
    $file = "$dir/$filename";

    if ((-f $file) && ($#cksum_size > 0)) {
        $cksum = EDRu::cksum($file);
        $size = EDR::cmd_local("_cmd_ls -l $file");
        $size=(split /\s+/, $size)[4];
        return 1 if (($cksum eq $cksum_size[0]) && ($size  eq $cksum_size[1]));
    }

    return 0;
}

sub apply_must_have_patch {
    my ($cpic,$patch_path) = @_;
    my ($msg,$pm,$install_script,$install_path,$cmd);
    my $edr=Obj::edr();
    my $rel=Obj::rel();

    $install_script= $cpic->{script};
    $install_path = $cpic->{scriptdir};
    if ($patch_path && ! -d $patch_path) {
        return 0;
    } else {
        if (!-d "$patch_path/scripts") {
            $msg = Msg::new("The downloaded patch is invalid. Contact our technical support for further troubleshooting.", 30, 2641);
            $msg->error;
            return 0;
        }
    }

    # Add this hotfix
    my ($path1,$path2,$sub);
    for my $path (qw/hotfix_path hotfix2_path hotfix3_path hotfix4_path hotfix5_path/) {
        if (Cfg::opt("$path")) {
            $path2=$path;
            next;
        }
        $path1=$path;
        last;
    }

    Cfg::set_opt($path1,$patch_path);
    $sub="process_$path1\_arg";
    $sub=~s/patch/hotfix/;
    $cpic->$sub($path1,$path2);
    
    # create hotfix and patch object
    my ($hf,$hotfix,$pkg,$patch,$pkglist,@pkgs,$prod,$subprod,$padv);
    $padv=$rel->{padv};
    $hf=$cpic->{hotfixes}[-1];
    $hotfix=init_cpip_object("Hotfix::$hf",$padv);
    push(@{$cpic->{hotfixobj}},$hotfix);

    $hotfix->{arg}=$cpic->{hotfix_arg}{$hf} if (defined($cpic->{hotfix_arg}{$hf}));
    $hotfix->define_patches();

    # re-initiate $pkg objects since they may be affected by the new patches
    push(@pkgs, @{$rel->allpkgs});
    for my $prodv (@{$rel->{prods}}) {
        $prod=$rel->prod($prodv);
        push(@pkgs, @{$prod->allpkgs_on_media});
        for my $subprodv(@{$prod->{subprods}}) {
            $prod=$rel->prod($subprodv);
            push(@pkgs, @{$prod->allpkgs_on_media});
        }
    }

    $pkglist=EDRu::arruniq(@pkgs);
    for my $pkgi (@{$pkglist}) {
        $pkg=init_cpip_object("Pkg::$pkgi",$padv);
        $pkg->init();
    }

    for my $patchi (@{$hotfix->{patches}}) {
        $patch=new_object("Patch::$patchi",$padv);
        if ($patch->{patch} =~ /^([a-zA-Z0-9]+)_(\d+)_(\d+)/mxg) {
            $patch->{pkg}="$1$2$3";
        }
        $patch->{arg}=$rel->{patcharg}{$patchi} if (defined($rel->{patcharg}{$patchi}));
    }
    # re-adjust package list
    $rel->adjust_pkglist();
    # re-verify media
    $cpic->verify_media($cpic->rel);
    return 1;
}

sub expand_must_have_patch {
    my ($cpic,$tar_path) = @_;
    my ($msg);

    EDR::cmd_local("cd $tar_path; _cmd_gunzip -c *.gz| _cmd_tar xf - 2>/dev/null");
    if (EDR::cmdexit()) {
        $msg = Msg::new("Failed to un-zip and un-tar the file under $tar_path.", 30, 2642, "$tar_path");
        $msg->error;
        return 0;
    }
    return 1;
}

package CPIP;

sub get_kernel_padv_sort_url {
    my $url;

    $url="http://sort.symantec.com/SORTServices/rest/matrix/1.0/padvmatrix?&source=cpi";
    return $url;
}

package Obj;

# $key can be comma separated to set 2d, 3d, and 4d hashes
# $value should be a hash reference
sub set_hash_value {
    my ($obj,$key,$value)=@_;
    my ($ref);

    $ref=ref($value);
    if ($ref eq "ARRAY") {
        $obj->set_value($key,'list',@{$value});
    } elsif ($ref eq "HASH") {
        for my $k (keys%{$value}) {
            $obj->set_hash_value("$key,$k",$value->{$k});
        }
    } else {
        $obj->set_value($key,$value);
    }
    return;
}

package EDRu;

sub eval_json {
    my ($content) = @_;
    my ($json,$jsonhash);
    $json = JSON->new->allow_nonref;
    eval { $jsonhash = $json->decode($content) };
    if ($@) {
        Msg::log("Failed to parse JSON string\n$@\n$content");
        return 0;
    }
    return $jsonhash;
}

sub isnic {
    my ($nic) = @_;
    # change the judgement condition of entered NIC format
    return 1 if ($nic=~/^\w+[\w\.:-]*$/mx);
    return 0;
}

package Hotfix;

# needs to be here instead of Rel.pm to set $hotfix->{arg}
sub define_hf_patches {
    #my ($hotfix,$pkgname,$platvers,$release,@patches)=(@_);
    my $hotfix=shift;
    $hotfix->rel->define_level_patches('hfpatches', $hotfix->{arg}, @_);
    $hotfix->define_hf_patches_list(@_);
    return 1;
}

# needs to leave a trace of what patches defined in this hotfix
# this info will help on postinstall/postremove of the hotfix
sub define_hf_patches_list {
    my ($hotfix,$pkgname,$platvers,$release,@patches)=(@_);
    $hotfix->{patches}||=[];
    for my $patch (@patches) {
        next if (!$patch);
        push (@{$hotfix->{patches}}, $patch)
            unless (EDRu::inarr($patch, @{$hotfix->{patches}}));
    }
    return 1;
}

package Rel;

sub initiate_kernel_padv_hash {
    my ($rel) = @_;
    my ($response,$url,$kernel_padv_file,$jsonhash,$jsontext,$jsonfile);
    my ($rootpath,$cpic,$edr,$perl_matrix,$local_matrix,$image_matrix,$level);

    return 1 if ($rel->{kernel_padv} && %{$rel->{kernel_padv}});
    $rootpath=Cfg::opt("rootpath");
    $cpic=Obj::cpic();
    $edr=Obj::edr();

    $jsonfile="kernel_padv.json";
    $perl_matrix="$rootpath/$edr->{perlpath}/lib/site_perl/$cpic->{release}/CPIP/Rel/Matrix/$jsonfile";
    $local_matrix="$rootpath/opt/VRTS/install/.matrix/$jsonfile";
    $image_matrix="$rootpath$edr->{scriptdir}/scripts/CPIP/Rel/Matrix/$jsonfile";

    if ($cpic->{sortready}) {
        # with SORT connection, download the latest kernel-padv matrix
        $url=CPIP::get_kernel_padv_sort_url();
        Msg::log("Downloading kernel padv matrix from URL '$url'");
        $response = EDRu::download_page($url);
        if ($response) {
            $jsonhash = EDRu::eval_json($response);
            if ($jsonhash) {
                # Save the matrix to local
                $jsontext=JSON::to_json($jsonhash,{pretty=>1});
                EDRu::mkdir_local_nosys(EDRu::dirname($local_matrix));
                EDRu::writefile($jsontext,$local_matrix);
            }
        }
    }
    if (!$jsonhash) {
        # without SORT connection/matrix download failed, use the local kernel-padv matrix
        for my $file($local_matrix,$image_matrix,$perl_matrix) {
            if (-f $file) {
                $jsonhash=$rel->get_matrix_data($file);
            }
            if ($jsonhash) {
                Msg::log("Using local kernel padv matrix json: $file");
                last;
            }
        }
    }

    if (!$jsonhash) {
        # for 6.1/6.1.1, there's no kernel_padv.json in the build
        # if there's no sort connection, we will get it locally
        $jsonhash = $rel->get_local_kernel_padv_hash();
    }
    
    # initiate the $jsonhash content into $rel->{kernel_padv}{$padv}{$kernel}
    for my $key (keys %{$jsonhash}) {
        $level=$jsonhash->{$key}{level};
        $level=~s/\D+(\d+)\D*/$1/mx;
        $rel->{kernel_padv}{$jsonhash->{$key}{padv}}{$key}=$level;
    }
    return 1;
}

sub get_local_kernel_padv_hash {
    my ($rel)=@_;
    my ($cpic,$response,$jsonhash,$rootpath,$local_jsonfile,$jsontext);

    $cpic=Obj::cpic();
    $rootpath = Cfg::opt("rootpath");
    $local_jsonfile = "$rootpath/opt/VRTS/install/.matrix/kernel_padv.json";
    $response = $rel->get_local_kernel_padv_response();

    $jsonhash = EDRu::eval_json($response);
    # if there's no SORT connnection and kernel_padv.json isn't there, write file to local matrix
    if (!-f $local_jsonfile && !$cpic->{sortready}) {
        $jsontext = JSON::to_json($jsonhash,{pretty=>1});
        EDRu::mkdir_local_nosys(EDRu::dirname($local_jsonfile));
        EDRu::writefile($jsontext,$local_jsonfile);
    }

    return $jsonhash;
}

# initiate the release matrix for target padv
sub init_sort_platvers {
    my ($rel)=@_;
    my ($response,$padv,$url,$jsontext,$jsonfile);
    my ($rootpath,$cpic,$edr,$perl_matrix_dir,$local_matrix_dir,$image_matrix_dir,$level);
    return 1 if (Padv::plat($rel->{padv}) ne 'Linux');
    return 1 if ($rel->{release_matrix} && %{$rel->{release_matrix}});
    $rootpath=Cfg::opt("rootpath");
    $cpic=Obj::cpic();
    $edr=Obj::edr();
    $padv=Padv::cpi_to_sort_padv($rel->{padv});
    $rel->set_value("sort_padv",$padv);

    $perl_matrix_dir="$rootpath/$edr->{perlpath}/lib/site_perl/$cpic->{release}/CPIP/Rel/Matrix/";
    $local_matrix_dir="$rootpath/opt/VRTS/install/.matrix/";
    $image_matrix_dir="$rootpath$edr->{scriptdir}/scripts/CPIP/Rel/Matrix/";
    
    # with SORT connection, download the latest $padv ga/patch/hotfix matrix
    for my $level (qw/ga patch hotfix/) {
        my $jsonhash;
        if ($cpic->{sortready}) {
            $url = CPIP::get_hotfix_sort_url();
            $url.= "?padv=$padv&level=$level&pretty=1&product=SFHA";
            Msg::log("Downloading release matrix data for $padv $level");
            $response = EDRu::download_page($url);
            if ($response) {
                $jsonhash = EDRu::eval_json($response);
                if ($jsonhash) {
                    # Save the matrix to local
                    $jsontext=JSON::to_json($jsonhash,{pretty=>1});
                    EDRu::mkdir_local_nosys($local_matrix_dir);
                    EDRu::writefile($jsontext,"$local_matrix_dir/$padv-$level.json");
                }
            }
        }
        if (!$jsonhash) {
            for my $dir ($local_matrix_dir,$image_matrix_dir,$perl_matrix_dir) {
                my $file="$dir/$padv-$level.json";
                if (-f $file) {
                    $jsonhash=$rel->get_matrix_data($file);
                }
                if ($jsonhash) {
                    Msg::log("Using local release matrix $padv $level json: $file");
                    last;
                }
            }
            if (!$jsonhash) {
                Msg::die("Cannot find release matrix json hash for $padv $level");
                return 0;
            }
        }
        $rel->{release_matrix}{$padv}{$level}=$jsonhash->{$padv};
    }
    return 1;
}

sub pre_platvers {
    my ($rel)=@_;
    my ($sort_padv,$matrix,$level);
    my ($msg,$common_sys,$cpic);
    $cpic=Obj::cpic();
    
    return 1 if (Padv::plat($rel->{padv}) ne 'Linux');
    $sort_padv=$rel->{sort_padv};
    if ($rel->{type}=~/M/) {
        $level='patch';
    } else {
        $level='ga';
    }
    $matrix=$rel->{release_matrix}{$sort_padv}{$level};
    while ( my ($id, $val) = each %{$matrix} ) {
        if (EDRu::compvers($val->{release_version},$rel->{vers})==0) {
            $rel->set_value('os_update_min', $val->{os_update_min});
            $rel->set_value('os_update_max', $val->{os_update_max});
            $rel->set_value('os_update_err', $val->{os_update_err});
            while ( my ($required_patch_update, $required_patch_id) = each %{$val->{required_patch}} ) {
                $rel->set_value("os_update_patchid_mapping,$required_patch_update", $required_patch_id);
            }
            last;
        }
    }
    # For 6.1/6.1.1 releases, we define the os_update_min/os_update_max in code for rhel5/6, sles10/11
    unless (defined($rel->{os_update_min})) {
        if ($sort_padv =~ /^rhel5/) {
            $rel->set_value('os_update_min', 5);
        } elsif ($sort_padv =~ /^rhel6/) {
            $rel->set_value('os_update_min', 3);
        } elsif ($sort_padv =~ /^sles11/) {
            $rel->set_value('os_update_min', 2);
        }
    }
    unless (defined($rel->{os_update_max})) {
        if ($sort_padv =~ /^rhel5/) {
            if ($rel->{titlevers} eq '6.1') {
                $rel->set_value('os_update_max', 10);
            } else {
                $rel->set_value('os_update_max', 11);
            }
        } elsif ($sort_padv =~ /^rhel6/) {
            $rel->set_value('os_update_max', 4);
        } elsif ($sort_padv =~ /^sles11/) {
            $rel->set_value('os_update_max', 3);
        }
    }

    Msg::log("Minimum OS update level supported: $rel->{os_update_min}");
    Msg::log("Maximum OS update level supported: $rel->{os_update_max}");
    Msg::log("Unsupported OS update level: $rel->{os_update_err}") if ($rel->{os_update_err});

    unless ($rel->{os_update_min} && $rel->{os_update_max}) {
        $common_sys=@{$cpic->{systems}}[0];
        $msg=Msg::new("Failed to retrieve supported $rel->{padv} update level from the release matrix, contact our technical support for further troubleshooting.");
        $common_sys->push_error($msg);
        for my $sys (@{$cpic->{systems}}) {
            $sys->set_value('stop_checks',1);
        }
    }
    
    return 1;
}

sub rollback_check_task { return 0;}

sub get_local_kernel_padv_response {
    my ($rel)=@_;
    my ($response);

    $response = '{
   "2.6.16.21-0.15" : {
      "gaDate" : "2006-08-18",
      "level" : "",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.21-0.25" : {
      "gaDate" : "2006-09-26",
      "level" : "",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.21-0.8" : {
      "gaDate" : "2006-07-01",
      "level" : "",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.27-0.6" : {
      "gaDate" : "2006-12-21",
      "level" : "",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.27-0.9" : {
      "gaDate" : "2007-02-23",
      "level" : "",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.46-0.12" : {
      "gaDate" : "2007-06-01",
      "level" : "SP1",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.46-0.14" : {
      "gaDate" : "2007-06-19",
      "level" : "SP1",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.53-0.16" : {
      "gaDate" : "2007-10-11",
      "level" : "SP1",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.53-0.18" : {
      "gaDate" : "2007-11-07",
      "level" : "SP1",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.53-0.8" : {
      "gaDate" : "2007-09-04",
      "level" : "SP1",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.54-0.2.10" : {
      "gaDate" : "2008-10-01",
      "level" : "SP1",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.54-0.2.11" : {
      "gaDate" : "2008-10-01",
      "level" : "SP1",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.54-0.2.12" : {
      "gaDate" : "2008-12-02",
      "level" : "SP1",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.54-0.2.3" : {
      "gaDate" : "2007-12-03",
      "level" : "SP1",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.54-0.2.5" : {
      "gaDate" : "2008-02-07",
      "level" : "SP1",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.54-0.2.8" : {
      "gaDate" : "2008-07-04",
      "level" : "SP1",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.101.1" : {
      "gaDate" : "2013-04-12",
      "level" : "SP4",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.103.1" : {
      "gaDate" : "2013-06-04",
      "level" : "SP4",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.105.1" : {
      "gaDate" : "2014-04-16",
      "level" : "SP4 - LTSS",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.107.1" : {
      "gaDate" : "2014-06-10",
      "level" : "SP4 - LTSS",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.113.1" : {
      "gaDate" : "2013-12-09",
      "level" : "SP3 - LTSS",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.123.1" : {
      "gaDate" : "2014-06-23",
      "level" : "SP3 - LTSS",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.132.1" : {
      "gaDate" : "2015-04-30",
      "level" : "SP4 - LTSS",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.21" : {
      "gaDate" : "2008-05-01",
      "level" : "SP2",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.23" : {
      "gaDate" : "2008-06-01",
      "level" : "SP2",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.25" : {
      "gaDate" : "2008-07-18",
      "level" : "SP2",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.27" : {
      "gaDate" : "2008-07-29",
      "level" : "SP2",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.29" : {
      "gaDate" : "2008-10-01",
      "level" : "SP2",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.30" : {
      "gaDate" : "2008-10-01",
      "level" : "SP2",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.31" : {
      "gaDate" : "2008-10-20",
      "level" : "SP2",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.33" : {
      "gaDate" : "2008-11-25",
      "level" : "SP2",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.34" : {
      "gaDate" : "2009-01-29",
      "level" : "SP2",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.35" : {
      "gaDate" : "2009-02-17",
      "level" : "SP2",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.37" : {
      "gaDate" : "2009-04-03",
      "level" : "SP2",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.39.3" : {
      "gaDate" : "2009-05-20",
      "level" : "SP2",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.42.10" : {
      "gaDate" : "2010-05-06",
      "level" : "SP2",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.42.11" : {
      "gaDate" : "2011-06-14",
      "level" : "SP2 - LTSS",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.42.4" : {
      "gaDate" : "2009-08-20",
      "level" : "SP2",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.42.5" : {
      "gaDate" : "2009-08-27",
      "level" : "SP2",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.42.54.1" : {
      "gaDate" : "2012-01-24",
      "level" : "SP2 - LTSS",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.42.7" : {
      "gaDate" : "2009-11-10",
      "level" : "SP2",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.42.8" : {
      "gaDate" : "2009-12-22",
      "level" : "SP2",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.42.9" : {
      "gaDate" : "2010-02-04",
      "level" : "SP2",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.54.5" : {
      "gaDate" : "2009-10-01",
      "level" : "SP3",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.57.1" : {
      "gaDate" : "2009-11-12",
      "level" : "SP3",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.58.1" : {
      "gaDate" : "2009-12-14",
      "level" : "SP3",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.59.1" : {
      "gaDate" : "2010-01-22",
      "level" : "SP3",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.60.1" : {
      "gaDate" : "2010-03-29",
      "level" : "SP3",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.62.1" : {
      "gaDate" : "2010-04-26",
      "level" : "SP3",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.66.1" : {
      "gaDate" : "2010-06-11",
      "level" : "SP3",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.67.1" : {
      "gaDate" : "2010-08-17",
      "level" : "SP3",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.68.1" : {
      "gaDate" : "2010-09-03",
      "level" : "SP3",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.69.1" : {
      "gaDate" : "2010-09-22",
      "level" : "SP3",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.74.7" : {
      "gaDate" : "2010-12-13",
      "level" : "SP3",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.76.8" : {
      "gaDate" : "2011-01-25",
      "level" : "SP3",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.77.1" : {
      "gaDate" : "2011-03-24",
      "level" : "SP3",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.79.1" : {
      "gaDate" : "2011-06-29",
      "level" : "SP3",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.81.2" : {
      "gaDate" : "2011-07-02",
      "level" : "SP3",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.83.2" : {
      "gaDate" : "2011-09-20",
      "level" : "SP3",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.85.1" : {
      "gaDate" : "2011-04-01",
      "level" : "SP4",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.87.1" : {
      "gaDate" : "2011-05-19",
      "level" : "SP4",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.89.1" : {
      "gaDate" : "2011-08-12",
      "level" : "SP4",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.91.1" : {
      "gaDate" : "2011-10-28",
      "level" : "SP4",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.93.1" : {
      "gaDate" : "2012-01-23",
      "level" : "SP4",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.95.1" : {
      "gaDate" : "2012-01-23",
      "level" : "SP4",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.97.1" : {
      "gaDate" : "2012-06-14",
      "level" : "SP4",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.16.60-0.99.1" : {
      "gaDate" : "2012-10-23",
      "level" : "SP4",
      "padv" : "sles10_x86_64",
      "platform" : "Linux"
   },
   "2.6.18-128" : {
      "gaDate" : "2009-01-20",
      "level" : "Update 3",
      "padv" : "rhel5_x86_64",
      "platform" : "Linux"
   },
   "2.6.18-164" : {
      "gaDate" : "2009-09-02",
      "level" : "Update 4",
      "padv" : "rhel5_x86_64",
      "platform" : "Linux"
   },
   "2.6.18-194" : {
      "gaDate" : "2010-03-30",
      "level" : "Update 5",
      "padv" : "rhel5_x86_64",
      "platform" : "Linux"
   },
   "2.6.18-238" : {
      "gaDate" : "2011-01-13",
      "level" : "Update 6",
      "padv" : "rhel5_x86_64",
      "platform" : "Linux"
   },
   "2.6.18-274" : {
      "gaDate" : "2011-07-21",
      "level" : "Update 7",
      "padv" : "rhel5_x86_64",
      "platform" : "Linux"
   },
   "2.6.18-308" : {
      "gaDate" : "2012-02-20",
      "level" : "Update 8",
      "padv" : "rhel5_x86_64",
      "platform" : "Linux"
   },
   "2.6.18-348" : {
      "gaDate" : "2013-01-07",
      "level" : "Update 9",
      "padv" : "rhel5_x86_64",
      "platform" : "Linux"
   },
   "2.6.18-371" : {
      "gaDate" : "2013-10-01",
      "level" : "Update 10",
      "padv" : "rhel5_x86_64",
      "platform" : "Linux"
   },
   "2.6.18-398" : {
      "gaDate" : "2014-09-16",
      "level" : "Update 11",
      "padv" : "rhel5_x86_64",
      "platform" : "Linux"
   },
   "2.6.18-53" : {
      "gaDate" : "2007-11-07",
      "level" : "Update 1",
      "padv" : "rhel5_x86_64",
      "platform" : "Linux"
   },
   "2.6.18-8" : {
      "gaDate" : "2007-03-15",
      "level" : "",
      "padv" : "rhel5_x86_64",
      "platform" : "Linux"
   },
   "2.6.18-92" : {
      "gaDate" : "2008-05-21",
      "level" : "Update 2",
      "padv" : "rhel5_x86_64",
      "platform" : "Linux"
   },
   "2.6.27.19-5.1" : {
      "gaDate" : "2009-03-01",
      "level" : "",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.27.21-0.1.2" : {
      "gaDate" : "2009-04-16",
      "level" : "",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.27.23-0.1.1" : {
      "gaDate" : "2009-06-09",
      "level" : "",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.27.25-0.1.1" : {
      "gaDate" : "2009-07-23",
      "level" : "",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.27.29-0.1.1" : {
      "gaDate" : "2009-08-20",
      "level" : "",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.27.37-0.1.1" : {
      "gaDate" : "2009-11-02",
      "level" : "",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.27.39-0.3.1" : {
      "gaDate" : "2009-12-02",
      "level" : "",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.27.42-0.1.1" : {
      "gaDate" : "2010-01-14",
      "level" : "",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.27.45-0.1.1" : {
      "gaDate" : "2010-03-02",
      "level" : "",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.27.48-0.1.1" : {
      "gaDate" : "2010-07-20",
      "level" : "",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.27.48-0.12.1" : {
      "gaDate" : "2010-09-22",
      "level" : "",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.27.48-0.6.1" : {
      "gaDate" : "2010-08-09",
      "level" : "",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.27.54-0.2.1" : {
      "gaDate" : "2010-10-26",
      "level" : "",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.32-131.0.15" : {
      "gaDate" : "2011-05-19",
      "level" : "Update 1",
      "padv" : "rhel6_x86_64",
      "platform" : "Linux"
   },
   "2.6.32-220" : {
      "gaDate" : "2011-12-06",
      "level" : "Update 2",
      "padv" : "rhel6_x86_64",
      "platform" : "Linux"
   },
   "2.6.32-279" : {
      "gaDate" : "2012-06-20",
      "level" : "Update 3",
      "padv" : "rhel6_x86_64",
      "platform" : "Linux"
   },
   "2.6.32-358" : {
      "gaDate" : "2013-02-21",
      "level" : "Update 4",
      "padv" : "rhel6_x86_64",
      "platform" : "Linux"
   },
   "2.6.32-431" : {
      "gaDate" : "2013-11-21",
      "level" : "Update 5",
      "padv" : "rhel6_x86_64",
      "platform" : "Linux"
   },
   "2.6.32-504" : {
      "gaDate" : "2014-10-14",
      "level" : "Update 6",
      "padv" : "rhel6_x86_64",
      "platform" : "Linux"
   },
   "2.6.32-573" : {
      "gaDate" : "2015-07-22",
      "level" : "Update 7",
      "padv" : "rhel6_x86_64",
      "platform" : "Linux"
   },
   "2.6.32-71" : {
      "gaDate" : "2010-11-09",
      "level" : "",
      "padv" : "rhel6_x86_64",
      "platform" : "Linux"
   },
   "2.6.32.12-0.7.1" : {
      "gaDate" : "2010-06-01",
      "level" : "SP1",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.32.13-0.4.1" : {
      "gaDate" : "2010-07-01",
      "level" : "SP1",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.32.13-0.5.1" : {
      "gaDate" : "2010-08-02",
      "level" : "SP1",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.32.19-0.2.1" : {
      "gaDate" : "2010-09-13",
      "level" : "SP1",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.32.19-0.3.1" : {
      "gaDate" : "2010-09-22",
      "level" : "SP1",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.32.23-0.3.1" : {
      "gaDate" : "2010-10-13",
      "level" : "SP1",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.32.24-0.2.1" : {
      "gaDate" : "2010-11-10",
      "level" : "SP1",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.32.27-0.2.2" : {
      "gaDate" : "2011-01-14",
      "level" : "SP1",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.32.29-0.3.1" : {
      "gaDate" : "2011-03-08",
      "level" : "SP1",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.32.36-0.5.2" : {
      "gaDate" : "2011-04-27",
      "level" : "SP1",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.32.43-0.4.1" : {
      "gaDate" : "2011-07-25",
      "level" : "SP1",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.32.45-0.3.2" : {
      "gaDate" : "2011-09-01",
      "level" : "SP1",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.32.46-0.3.1" : {
      "gaDate" : "2011-10-07",
      "level" : "SP1",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.32.49-0.3.1" : {
      "gaDate" : "2011-12-13",
      "level" : "SP1",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.32.54-0.3.1" : {
      "gaDate" : "2012-02-06",
      "level" : "SP1",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.32.59-0.13.1" : {
      "gaDate" : "2014-06-17",
      "level" : "SP1 - LTSS",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.32.59-0.15.2" : {
      "gaDate" : "2014-09-16",
      "level" : "SP1 - LTSS",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.32.59-0.17.1" : {
      "gaDate" : "2014-12-24",
      "level" : "SP1 - LTSS",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.32.59-0.19.1" : {
      "gaDate" : "2015-04-02",
      "level" : "SP1 - LTSS",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.32.59-0.3.1" : {
      "gaDate" : "2012-05-14",
      "level" : "SP1",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.32.59-0.7.1" : {
      "gaDate" : "2012-07-23",
      "level" : "SP1",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.32.59-0.9.1" : {
      "gaDate" : "2014-01-24",
      "level" : "SP1 - LTSS",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.104" : {
      "gaDate" : "2004-07-29",
      "level" : "",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.111" : {
      "gaDate" : null,
      "level" : "",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.111.19" : {
      "gaDate" : "2004-12-13",
      "level" : "",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.111.30" : {
      "gaDate" : "2005-01-17",
      "level" : "",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.111.5" : {
      "gaDate" : "2004-11-17",
      "level" : "",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.139" : {
      "gaDate" : "2005-01-01",
      "level" : "SP1",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.145" : {
      "gaDate" : "2005-01-28",
      "level" : "SP1",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.147" : {
      "gaDate" : "2005-02-24",
      "level" : "SP1",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.151" : {
      "gaDate" : "2005-03-17",
      "level" : "SP1",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.155.29" : {
      "gaDate" : "2005-06-03",
      "level" : "SP1",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.191" : {
      "gaDate" : "2005-07-01",
      "level" : "SP2",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.193" : {
      "gaDate" : "2005-07-29",
      "level" : "SP2",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.201" : {
      "gaDate" : "2005-08-28",
      "level" : "SP2",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.202.7" : {
      "gaDate" : "2005-12-02",
      "level" : "SP2",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.244" : {
      "gaDate" : "2005-12-01",
      "level" : "SP3",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.252" : {
      "gaDate" : "2006-02-16",
      "level" : "SP2",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.257" : {
      "gaDate" : "2006-05-15",
      "level" : "SP3",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.267" : {
      "gaDate" : "2006-06-23",
      "level" : "SP3",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.276" : {
      "gaDate" : "2006-07-25",
      "level" : "SP3",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.282" : {
      "gaDate" : "2006-08-30",
      "level" : "SP3",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.283" : {
      "gaDate" : "2006-12-04",
      "level" : "SP3",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.286" : {
      "gaDate" : "2007-06-04",
      "level" : "SP3",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.287.3" : {
      "gaDate" : "2007-10-09",
      "level" : "SP3",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.308" : {
      "gaDate" : "2007-12-01",
      "level" : "SP4",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.311" : {
      "gaDate" : "2008-03-31",
      "level" : "SP4",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.312" : {
      "gaDate" : "2008-06-24",
      "level" : "SP4",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.314" : {
      "gaDate" : "2008-09-30",
      "level" : "SP4",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.315" : {
      "gaDate" : "2008-12-04",
      "level" : "SP4",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.316" : {
      "gaDate" : "2009-03-27",
      "level" : "SP4",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.317" : {
      "gaDate" : "2009-06-16",
      "level" : "SP4",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.318" : {
      "gaDate" : "2009-08-21",
      "level" : "SP4",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.319" : {
      "gaDate" : "2009-08-28",
      "level" : "SP4",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.321" : {
      "gaDate" : "2009-11-16",
      "level" : "SP4",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.322" : {
      "gaDate" : "2010-02-17",
      "level" : "SP4",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.323" : {
      "gaDate" : "2010-08-26",
      "level" : "SP4",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.324" : {
      "gaDate" : "2010-09-22",
      "level" : "SP4",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.325" : {
      "gaDate" : "2011-02-11",
      "level" : "SP4",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.5-7.97" : {
      "gaDate" : "2004-07-01",
      "level" : "",
      "padv" : "sles9_x86_64",
      "platform" : "Linux"
   },
   "2.6.9-100" : {
      "gaDate" : "2011-02-16",
      "level" : "Update 9",
      "padv" : "rhel4_x86_64",
      "platform" : "Linux"
   },
   "2.6.9-11" : {
      "gaDate" : "2005-06-08",
      "level" : "Update 1",
      "padv" : "rhel4_x86_64",
      "platform" : "Linux"
   },
   "2.6.9-22" : {
      "gaDate" : "2005-10-05",
      "level" : "Update 2",
      "padv" : "rhel4_x86_64",
      "platform" : "Linux"
   },
   "2.6.9-34" : {
      "gaDate" : "2006-03-12",
      "level" : "Update 3",
      "padv" : "rhel4_x86_64",
      "platform" : "Linux"
   },
   "2.6.9-42" : {
      "gaDate" : "2006-08-10",
      "level" : "Update 4",
      "padv" : "rhel4_x86_64",
      "platform" : "Linux"
   },
   "2.6.9-5" : {
      "gaDate" : "2005-02-15",
      "level" : "",
      "padv" : "rhel4_x86_64",
      "platform" : "Linux"
   },
   "2.6.9-55" : {
      "gaDate" : "2007-05-01",
      "level" : "Update 5",
      "padv" : "rhel4_x86_64",
      "platform" : "Linux"
   },
   "2.6.9-67" : {
      "gaDate" : "2007-11-15",
      "level" : "Update 6",
      "padv" : "rhel4_x86_64",
      "platform" : "Linux"
   },
   "2.6.9-78" : {
      "gaDate" : "2008-07-29",
      "level" : "Update 7",
      "padv" : "rhel4_x86_64",
      "platform" : "Linux"
   },
   "2.6.9-89" : {
      "gaDate" : "2009-05-19",
      "level" : "Update 8",
      "padv" : "rhel4_x86_64",
      "platform" : "Linux"
   },
   "3.0.101-0.15.1" : {
      "gaDate" : "2014-02-04",
      "level" : "SP3",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.101-0.21.1" : {
      "gaDate" : "2014-04-15",
      "level" : "SP3",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.101-0.29.1" : {
      "gaDate" : "2014-05-15",
      "level" : "SP3",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.101-0.31.1" : {
      "gaDate" : "2014-06-11",
      "level" : "SP3",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.101-0.35.1" : {
      "gaDate" : "2014-07-17",
      "level" : "SP3",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.101-0.40.1" : {
      "gaDate" : "2014-10-22",
      "level" : "SP3",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.101-0.42.1" : {
      "gaDate" : "2014-12-23",
      "level" : "SP3",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.101-0.46.1" : {
      "gaDate" : "2014-12-23",
      "level" : "SP3",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.101-0.47.52.1" : {
      "gaDate" : "2015-03-27",
      "level" : "SP3",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.101-0.47.55-default" : {
      "gaDate" : "2015-07-02",
      "level" : "SP3",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.101-0.47.55.1" : {
      "gaDate" : "2015-07-02",
      "level" : "SP3",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.101-0.5.1" : {
      "gaDate" : "2013-11-21",
      "level" : "SP2",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.101-0.63.1" : {
      "gaDate" : "2015-07-01",
      "level" : "SP4",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.101-0.7.15.1" : {
      "gaDate" : "2014-01-27",
      "level" : "SP2",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.101-0.7.17.1" : {
      "gaDate" : "2014-02-12",
      "level" : "SP2",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.101-0.7.19.1" : {
      "gaDate" : "2014-05-21",
      "level" : "SP2 - LTSS",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.101-0.7.21.1" : {
      "gaDate" : "2014-06-24",
      "level" : "SP2 - LTSS",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.101-0.7.23.1" : {
      "gaDate" : "2014-09-09",
      "level" : "SP2 - LTSS",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.101-0.7.27.1" : {
      "gaDate" : "2014-12-24",
      "level" : "SP2 - LTSS",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.101-0.7.29.1" : {
      "gaDate" : "2015-03-11",
      "level" : "SP2 - LTSS",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.101-0.8.1" : {
      "gaDate" : "2013-11-22",
      "level" : "SP3",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.101-63-default" : {
      "gaDate" : "2015-07-01",
      "level" : "SP4",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.13-0.27-default" : {
      "gaDate" : "2012-02-01",
      "level" : "SP2",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.13-0.27.1" : {
      "gaDate" : "2012-02-01",
      "level" : "SP2",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.26-0.7.6" : {
      "gaDate" : "2012-04-23",
      "level" : "SP2",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.31-0.9.1" : {
      "gaDate" : "2012-06-01",
      "level" : "SP2",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.34-0.7.9" : {
      "gaDate" : "2012-06-25",
      "level" : "SP2",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.38-0.5.1" : {
      "gaDate" : "2012-08-21",
      "level" : "SP2",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.42-0.7.3" : {
      "gaDate" : "2012-10-15",
      "level" : "SP2",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.51-0.7.9.1" : {
      "gaDate" : "2012-12-19",
      "level" : "SP2",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.58-0.6.2.1" : {
      "gaDate" : "2013-02-07",
      "level" : "SP2",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.58-0.6.6.1" : {
      "gaDate" : "2013-02-25",
      "level" : "SP2",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.74-0.6.10.1" : {
      "gaDate" : "2013-05-31",
      "level" : "SP2",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.74-0.6.6.2" : {
      "gaDate" : "2013-05-07",
      "level" : "SP2",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.74-0.6.8.1" : {
      "gaDate" : "2013-05-22",
      "level" : "SP2",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.76-0.11.1" : {
      "gaDate" : "2013-07-01",
      "level" : "SP3",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.80-0.5.1" : {
      "gaDate" : "2013-06-17",
      "level" : "SP2",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.80-0.7.1" : {
      "gaDate" : "2013-07-05",
      "level" : "SP2",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.82-0.7.9" : {
      "gaDate" : "2013-07-11",
      "level" : "SP3",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.93-0.5.1" : {
      "gaDate" : "2013-09-20",
      "level" : "SP2",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.0.93-0.8.2" : {
      "gaDate" : "2013-09-21",
      "level" : "SP3",
      "padv" : "sles11_x86_64",
      "platform" : "Linux"
   },
   "3.10.0-123" : {
      "gaDate" : "2014-06-09",
      "level" : "",
      "padv" : "rhel7_x86_64",
      "platform" : "Linux"
   },
   "3.10.0-229" : {
      "gaDate" : "2015-03-05",
      "level" : "Update 1",
      "padv" : "rhel7_x86_64",
      "platform" : "Linux"
   },
   "3.12.28-4.6" : {
      "gaDate" : "2014-11-01",
      "level" : "",
      "padv" : "sles12_x86_64",
      "platform" : "Linux"
   },
   "3.12.32-33.1" : {
      "gaDate" : "2015-01-16",
      "level" : "",
      "padv" : "sles12_x86_64",
      "platform" : "Linux"
   },
   "3.12.36-38.1" : {
      "gaDate" : "2015-01-30",
      "level" : "",
      "padv" : "sles12_x86_64",
      "platform" : "Linux"
   },
   "3.12.38-44.1" : {
      "gaDate" : "2015-03-18",
      "level" : "",
      "padv" : "sles12_x86_64",
      "platform" : "Linux"
   },
   "3.12.39-47.1" : {
      "gaDate" : "2015-04-02",
      "level" : "",
      "padv" : "sles12_x86_64",
      "platform" : "Linux"
   },
   "3.12.43-52.6.1" : {
      "gaDate" : "2015-06-16",
      "level" : "",
      "padv" : "sles12_x86_64",
      "platform" : "Linux"
   },
   "3.12.44-52.10.1" : {
      "gaDate" : "2015-07-31",
      "level" : "",
      "padv" : "sles12_x86_64",
      "platform" : "Linux"
   },
   "TBA" : {
      "gaDate" : null,
      "level" : "Update 2",
      "padv" : "rhel7_x86_64",
      "platform" : "Linux"
   }
}'
;

    return $response;
}

package Pkg::VRTScps61::Common;

sub check_nic_sys {
    my ($sys,$nic) = @_;
    my ($ret);

    # ([a-z]+(\d)+) -- pattern begins with lowercase chars and ends with digits
    # {1,2} -- above pattern can repeat exactly once('hme0') or twice ('e1000g0')
    if (EDRu::isnic($nic)) {
        # Valid NIC device
        # Check if NIC is configured on the system
        if ($sys->hpux()) {
            $sys->cmd("/usr/sbin/nwmgr | _cmd_grep '^$nic'");
        } else {
            $sys->cmd("_cmd_ifconfig -a | _cmd_grep '^$nic'");
        }
        (EDR::cmdexit()) ? return 0 : return 1;
    }
    return 0;
}

1;
